searchData={"items":[{"type":"module","title":"Idmlx","doc":"IDMLX is a library for parsing, editing and converting IDMS (InDesign Markup Snippet) files.","ref":"Idmlx.html"},{"type":"module","title":"Examples - Idmlx","doc":"iex> Idmlx.read_idms(\"path/to/file.idms\")\n    %{spread: %Spread{...}}\n\n    iex> Idmlx.read_idml(\"path/to/file.idml\")\n    {fonts, tags, styles, pages}","ref":"Idmlx.html#module-examples"},{"type":"function","title":"Idmlx.assign_font/4","doc":"","ref":"Idmlx.html#assign_font/4"},{"type":"function","title":"Idmlx.export_to_html/3","doc":"","ref":"Idmlx.html#export_to_html/3"},{"type":"function","title":"Idmlx.export_to_konva/3","doc":"","ref":"Idmlx.html#export_to_konva/3"},{"type":"function","title":"Idmlx.export_to_pdf/3","doc":"","ref":"Idmlx.html#export_to_pdf/3"},{"type":"function","title":"Idmlx.graphics/1","doc":"","ref":"Idmlx.html#graphics/1"},{"type":"function","title":"Idmlx.graphics_assign_keys/1","doc":"","ref":"Idmlx.html#graphics_assign_keys/1"},{"type":"function","title":"Idmlx.import_from_konva/1","doc":"","ref":"Idmlx.html#import_from_konva/1"},{"type":"function","title":"Idmlx.parse_idml/2","doc":"","ref":"Idmlx.html#parse_idml/2"},{"type":"function","title":"Idmlx.parse_idms/2","doc":"","ref":"Idmlx.html#parse_idms/2"},{"type":"function","title":"Idmlx.read_idml/2","doc":"","ref":"Idmlx.html#read_idml/2"},{"type":"function","title":"Idmlx.read_idms/2","doc":"","ref":"Idmlx.html#read_idms/2"},{"type":"function","title":"Idmlx.text_frames/1","doc":"Extracts all text frames from a spread.","ref":"Idmlx.html#text_frames/1"},{"type":"function","title":"Idmlx.text_frames_assign_keys/1","doc":"","ref":"Idmlx.html#text_frames_assign_keys/1"},{"type":"function","title":"Idmlx.update_idms/3","doc":"","ref":"Idmlx.html#update_idms/3"},{"type":"module","title":"Idmlx.CSS.CharacterStyleMapper","doc":"","ref":"Idmlx.CSS.CharacterStyleMapper.html"},{"type":"function","title":"Idmlx.CSS.CharacterStyleMapper.get_css_value/1","doc":"","ref":"Idmlx.CSS.CharacterStyleMapper.html#get_css_value/1"},{"type":"function","title":"Idmlx.CSS.CharacterStyleMapper.map_paragraph_style_to_css/1","doc":"","ref":"Idmlx.CSS.CharacterStyleMapper.html#map_paragraph_style_to_css/1"},{"type":"module","title":"Idmlx.CSS.ObjectStyleMapper","doc":"","ref":"Idmlx.CSS.ObjectStyleMapper.html"},{"type":"function","title":"Idmlx.CSS.ObjectStyleMapper.get_css_value/1","doc":"","ref":"Idmlx.CSS.ObjectStyleMapper.html#get_css_value/1"},{"type":"function","title":"Idmlx.CSS.ObjectStyleMapper.map_object_style_to_css/1","doc":"","ref":"Idmlx.CSS.ObjectStyleMapper.html#map_object_style_to_css/1"},{"type":"module","title":"Idmlx.CSS.ParagraphStyleMapper","doc":"","ref":"Idmlx.CSS.ParagraphStyleMapper.html"},{"type":"function","title":"Idmlx.CSS.ParagraphStyleMapper.get_css_value/1","doc":"","ref":"Idmlx.CSS.ParagraphStyleMapper.html#get_css_value/1"},{"type":"function","title":"Idmlx.CSS.ParagraphStyleMapper.map_paragraph_attribute/1","doc":"","ref":"Idmlx.CSS.ParagraphStyleMapper.html#map_paragraph_attribute/1"},{"type":"function","title":"Idmlx.CSS.ParagraphStyleMapper.map_paragraph_style_to_css/1","doc":"","ref":"Idmlx.CSS.ParagraphStyleMapper.html#map_paragraph_style_to_css/1"},{"type":"module","title":"Idmlx.Components.Color","doc":"Represents a color in an InDesign document.\n\nThis module provides functionality for handling color definitions and conversions\nbetween different color spaces (CMYK, RGB, HEX).","ref":"Idmlx.Components.Color.html"},{"type":"module","title":"Color Spaces - Idmlx.Components.Color","doc":"- CMYK: Used for print documents\n- RGB: Used for digital/screen documents\n- HEX: Web color format (converted to appropriate space)","ref":"Idmlx.Components.Color.html#module-color-spaces"},{"type":"module","title":"Examples - Idmlx.Components.Color","doc":"%Idmlx.Components.Color{\n      name: \"CustomBlue\",\n      model: \"Process\",\n      space: \"CMYK\",\n      color_value: \"100 50 0 0\"\n    }","ref":"Idmlx.Components.Color.html#module-examples"},{"type":"type","title":"Idmlx.Components.Color.t/0","doc":"","ref":"Idmlx.Components.Color.html#t:t/0"},{"type":"function","title":"Idmlx.Components.Color.to_hex/1","doc":"Returns hexadecimal value for predefined colors.","ref":"Idmlx.Components.Color.html#to_hex/1"},{"type":"module","title":"Idmlx.Components.Colors","doc":"Provides functionality for parsing and working with InDesign colors.\n\nThis module handles the parsing of color definitions from IDMS files and provides\nutilities for working with collections of colors.","ref":"Idmlx.Components.Colors.html"},{"type":"module","title":"Examples - Idmlx.Components.Colors","doc":"# Parse colors from an IDMS file\n    colors = Idmlx.Components.Colors.parse_colors(\"path/to/file.idms\")\n\n    # Find a specific color by name\n    black = Idmlx.Components.Colors.find_color_by_name(colors, \"Black\")","ref":"Idmlx.Components.Colors.html#module-examples"},{"type":"function","title":"Idmlx.Components.Colors.find_color_by_name/2","doc":"Finds a color by name in a list of colors.\nSupports both direct name matching and \"Color/\" prefixed names.","ref":"Idmlx.Components.Colors.html#find_color_by_name/2"},{"type":"function","title":"Parameters - Idmlx.Components.Colors.find_color_by_name/2","doc":"- colors: List of Color structs to search\n  - name: Name of the color to find","ref":"Idmlx.Components.Colors.html#find_color_by_name/2-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Colors.find_color_by_name/2","doc":"Color struct or nil if not found","ref":"Idmlx.Components.Colors.html#find_color_by_name/2-returns"},{"type":"function","title":"Examples - Idmlx.Components.Colors.find_color_by_name/2","doc":"iex> colors = [%Color{name: \"Black\"}, %Color{name: \"Red\"}]\n    iex> Idmlx.Components.Colors.find_color_by_name(colors, \"Black\")\n    %Color{name: \"Black\", ...}\n\n    iex> Idmlx.Components.Colors.find_color_by_name(colors, \"Color/Black\")\n    %Color{name: \"Black\", ...}","ref":"Idmlx.Components.Colors.html#find_color_by_name/2-examples"},{"type":"function","title":"Idmlx.Components.Colors.parse_colors/1","doc":"Parses color definitions from an IDMS file.","ref":"Idmlx.Components.Colors.html#parse_colors/1"},{"type":"function","title":"Parameters - Idmlx.Components.Colors.parse_colors/1","doc":"- file_path: Path to the IDMS file to parse","ref":"Idmlx.Components.Colors.html#parse_colors/1-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Colors.parse_colors/1","doc":"List of Color structs","ref":"Idmlx.Components.Colors.html#parse_colors/1-returns"},{"type":"function","title":"Examples - Idmlx.Components.Colors.parse_colors/1","doc":"iex> Idmlx.Components.Colors.parse_colors(\"template.idms\")\n    [%Idmlx.Components.Color{name: \"Black\", model: \"Process\", space: \"CMYK\", ...}]","ref":"Idmlx.Components.Colors.html#parse_colors/1-examples"},{"type":"behaviour","title":"Idmlx.Components.Element","doc":"Behaviour and utilities for InDesign document elements.\n\nThis module provides common functionality shared across different InDesign elements\n(TextFrames, Rectangles, Polygons, etc.), including:\n- Attribute extraction\n- Geometric calculations\n- Style handling\n- Transformation processing\n- HTML/CSS conversion support","ref":"Idmlx.Components.Element.html"},{"type":"behaviour","title":"Element Properties - Idmlx.Components.Element","doc":"Common properties handled by this module:\n- Names and identifiers\n- Content types\n- Style references\n- Geometric properties\n- Transformations\n- Attributes and preferences","ref":"Idmlx.Components.Element.html#module-element-properties"},{"type":"behaviour","title":"Coordinate System - Idmlx.Components.Element","doc":"Uses InDesign's coordinate system:\n- Origin at top-left\n- Positive X to the right\n- Positive Y downward\n- Units in points (1/72 inch)","ref":"Idmlx.Components.Element.html#module-coordinate-system"},{"type":"function","title":"Idmlx.Components.Element.embed_object_style/2","doc":"Embeds object style in an element.","ref":"Idmlx.Components.Element.html#embed_object_style/2"},{"type":"function","title":"Parameters - Idmlx.Components.Element.embed_object_style/2","doc":"- element: Element to update\n  - styles: List of available styles","ref":"Idmlx.Components.Element.html#embed_object_style/2-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Element.embed_object_style/2","doc":"Updated element with embedded style","ref":"Idmlx.Components.Element.html#embed_object_style/2-returns"},{"type":"function","title":"Idmlx.Components.Element.embed_paragraph_style/2","doc":"Embeds paragraph style in an element if applicable.","ref":"Idmlx.Components.Element.html#embed_paragraph_style/2"},{"type":"function","title":"Parameters - Idmlx.Components.Element.embed_paragraph_style/2","doc":"- element: Element to update\n  - styles: List of available styles","ref":"Idmlx.Components.Element.html#embed_paragraph_style/2-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Element.embed_paragraph_style/2","doc":"Updated element with embedded style","ref":"Idmlx.Components.Element.html#embed_paragraph_style/2-returns"},{"type":"function","title":"Idmlx.Components.Element.format_rotation/1","doc":"Formats rotation from a transformation matrix.","ref":"Idmlx.Components.Element.html#format_rotation/1"},{"type":"function","title":"Parameters - Idmlx.Components.Element.format_rotation/1","doc":"- item_transform: Transformation matrix\n  - _: Optional additional parameters","ref":"Idmlx.Components.Element.html#format_rotation/1-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Element.format_rotation/1","doc":"CSS rotation string or empty string","ref":"Idmlx.Components.Element.html#format_rotation/1-returns"},{"type":"function","title":"Examples - Idmlx.Components.Element.format_rotation/1","doc":"iex> Element.format_rotation([0.866, 0.5, -0.5, 0.866, 0, 0])\n    \"transform: rotate(30deg);\"","ref":"Idmlx.Components.Element.html#format_rotation/1-examples"},{"type":"function","title":"Idmlx.Components.Element.get_all_attributes/1","doc":"Gets all attributes from an XML element.","ref":"Idmlx.Components.Element.html#get_all_attributes/1"},{"type":"function","title":"Parameters - Idmlx.Components.Element.get_all_attributes/1","doc":"- xml: XML fragment to extract attributes from","ref":"Idmlx.Components.Element.html#get_all_attributes/1-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Element.get_all_attributes/1","doc":"List of attribute maps with :key and :value pairs","ref":"Idmlx.Components.Element.html#get_all_attributes/1-returns"},{"type":"function","title":"Examples - Idmlx.Components.Element.get_all_attributes/1","doc":"iex> Element.get_all_attributes(xml_fragment)\n    [%{key: :Name, value: \"rectangle_1\"}, %{key: :ContentType, value: \"GraphicType\"}]","ref":"Idmlx.Components.Element.html#get_all_attributes/1-examples"},{"type":"function","title":"Idmlx.Components.Element.get_attribute_value/2","doc":"Gets a specific attribute value from a style.","ref":"Idmlx.Components.Element.html#get_attribute_value/2"},{"type":"function","title":"Parameters - Idmlx.Components.Element.get_attribute_value/2","doc":"- style: Style struct containing attributes\n  - key: Attribute key to look up","ref":"Idmlx.Components.Element.html#get_attribute_value/2-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Element.get_attribute_value/2","doc":"Normalized attribute value or nil","ref":"Idmlx.Components.Element.html#get_attribute_value/2-returns"},{"type":"function","title":"Examples - Idmlx.Components.Element.get_attribute_value/2","doc":"iex> Element.get_attribute_value(style, :PointSize)\n    12.0","ref":"Idmlx.Components.Element.html#get_attribute_value/2-examples"},{"type":"function","title":"Idmlx.Components.Element.get_bounding_box/1","doc":"Gets the bounding box for an element.","ref":"Idmlx.Components.Element.html#get_bounding_box/1"},{"type":"function","title":"Parameters - Idmlx.Components.Element.get_bounding_box/1","doc":"- xml: XML fragment containing geometry data","ref":"Idmlx.Components.Element.html#get_bounding_box/1-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Element.get_bounding_box/1","doc":"Map of bounding box coordinates","ref":"Idmlx.Components.Element.html#get_bounding_box/1-returns"},{"type":"function","title":"Examples - Idmlx.Components.Element.get_bounding_box/1","doc":"iex> Element.get_bounding_box(xml_fragment)\n    %{\"x1\" => 0.0, \"y1\" => 0.0, \"x2\" => 100.0, \"y2\" => 100.0}","ref":"Idmlx.Components.Element.html#get_bounding_box/1-examples"},{"type":"function","title":"Idmlx.Components.Element.get_content_type/1","doc":"Gets the content type attribute from an XML element.","ref":"Idmlx.Components.Element.html#get_content_type/1"},{"type":"function","title":"Parameters - Idmlx.Components.Element.get_content_type/1","doc":"- xml: XML fragment to extract content type from","ref":"Idmlx.Components.Element.html#get_content_type/1-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Element.get_content_type/1","doc":"Content type string or nil","ref":"Idmlx.Components.Element.html#get_content_type/1-returns"},{"type":"function","title":"Examples - Idmlx.Components.Element.get_content_type/1","doc":"iex> Element.get_content_type(xml_fragment)\n    \"GraphicType\"","ref":"Idmlx.Components.Element.html#get_content_type/1-examples"},{"type":"function","title":"Idmlx.Components.Element.get_dimensions/1","doc":"Gets dimensions from a bounding box.","ref":"Idmlx.Components.Element.html#get_dimensions/1"},{"type":"function","title":"Parameters - Idmlx.Components.Element.get_dimensions/1","doc":"- xml: XML fragment containing geometry data","ref":"Idmlx.Components.Element.html#get_dimensions/1-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Element.get_dimensions/1","doc":"Map of width and height values","ref":"Idmlx.Components.Element.html#get_dimensions/1-returns"},{"type":"function","title":"Examples - Idmlx.Components.Element.get_dimensions/1","doc":"iex> Element.get_dimensions(xml_fragment)\n    %{\"width\" => 100.0, \"height\" => 100.0}","ref":"Idmlx.Components.Element.html#get_dimensions/1-examples"},{"type":"function","title":"Idmlx.Components.Element.get_item_transform/1","doc":"Gets the transformation matrix from an XML element.","ref":"Idmlx.Components.Element.html#get_item_transform/1"},{"type":"function","title":"Parameters - Idmlx.Components.Element.get_item_transform/1","doc":"- xml: XML fragment to extract transform from","ref":"Idmlx.Components.Element.html#get_item_transform/1-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Element.get_item_transform/1","doc":"List of 6 float values [a, b, c, d, tx, ty] or default matrix","ref":"Idmlx.Components.Element.html#get_item_transform/1-returns"},{"type":"function","title":"Examples - Idmlx.Components.Element.get_item_transform/1","doc":"iex> Element.get_item_transform(xml_fragment)\n    [1.0, 0.0, 0.0, 1.0, 100.0, 200.0]","ref":"Idmlx.Components.Element.html#get_item_transform/1-examples"},{"type":"function","title":"Idmlx.Components.Element.get_konva_rotation_props/1","doc":"Gets Konva rotation properties for an element.","ref":"Idmlx.Components.Element.html#get_konva_rotation_props/1"},{"type":"function","title":"Parameters - Idmlx.Components.Element.get_konva_rotation_props/1","doc":"- element: Element to get properties for","ref":"Idmlx.Components.Element.html#get_konva_rotation_props/1-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Element.get_konva_rotation_props/1","doc":"Map of position properties or empty map","ref":"Idmlx.Components.Element.html#get_konva_rotation_props/1-returns"},{"type":"function","title":"Examples - Idmlx.Components.Element.get_konva_rotation_props/1","doc":"iex> Element.get_konva_rotation_props(element)\n    %{\"x\" => 100.0, \"y\" => 200.0}","ref":"Idmlx.Components.Element.html#get_konva_rotation_props/1-examples"},{"type":"function","title":"Idmlx.Components.Element.get_name/1","doc":"Gets the name attribute from an XML element.","ref":"Idmlx.Components.Element.html#get_name/1"},{"type":"function","title":"Parameters - Idmlx.Components.Element.get_name/1","doc":"- xml: XML fragment to extract name from","ref":"Idmlx.Components.Element.html#get_name/1-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Element.get_name/1","doc":"Name string or nil","ref":"Idmlx.Components.Element.html#get_name/1-returns"},{"type":"function","title":"Examples - Idmlx.Components.Element.get_name/1","doc":"iex> Element.get_name(xml_fragment)\n    \"rectangle_1\"","ref":"Idmlx.Components.Element.html#get_name/1-examples"},{"type":"function","title":"Idmlx.Components.Element.get_object_style_name/1","doc":"Gets the object style name from an XML element.","ref":"Idmlx.Components.Element.html#get_object_style_name/1"},{"type":"function","title":"Parameters - Idmlx.Components.Element.get_object_style_name/1","doc":"- xml: XML fragment to extract style from","ref":"Idmlx.Components.Element.html#get_object_style_name/1-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Element.get_object_style_name/1","doc":"Object style name string or nil","ref":"Idmlx.Components.Element.html#get_object_style_name/1-returns"},{"type":"function","title":"Examples - Idmlx.Components.Element.get_object_style_name/1","doc":"iex> Element.get_object_style_name(xml_fragment)\n    \"ObjectStyle/Basic\"","ref":"Idmlx.Components.Element.html#get_object_style_name/1-examples"},{"type":"function","title":"Idmlx.Components.Element.get_points/1","doc":"Gets transformed points from an XML element.","ref":"Idmlx.Components.Element.html#get_points/1"},{"type":"function","title":"Parameters - Idmlx.Components.Element.get_points/1","doc":"- xml: XML fragment containing point data","ref":"Idmlx.Components.Element.html#get_points/1-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Element.get_points/1","doc":"List of transformed point coordinates","ref":"Idmlx.Components.Element.html#get_points/1-returns"},{"type":"function","title":"Examples - Idmlx.Components.Element.get_points/1","doc":"iex> Element.get_points(xml_fragment)\n    [[0.0, 0.0], [100.0, 0.0], [100.0, 100.0], [0.0, 100.0]]","ref":"Idmlx.Components.Element.html#get_points/1-examples"},{"type":"function","title":"Idmlx.Components.Element.get_preference_value/2","doc":"Gets a specific preference value from an element.","ref":"Idmlx.Components.Element.html#get_preference_value/2"},{"type":"function","title":"Parameters - Idmlx.Components.Element.get_preference_value/2","doc":"- element: Element struct containing preferences\n  - key: Preference key to look up","ref":"Idmlx.Components.Element.html#get_preference_value/2-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Element.get_preference_value/2","doc":"Normalized preference value or nil","ref":"Idmlx.Components.Element.html#get_preference_value/2-returns"},{"type":"function","title":"Examples - Idmlx.Components.Element.get_preference_value/2","doc":"iex> Element.get_preference_value(element, :VerticalJustification)\n    \"CenterAlign\"","ref":"Idmlx.Components.Element.html#get_preference_value/2-examples"},{"type":"callback","title":"Idmlx.Components.Element.parse/1","doc":"","ref":"Idmlx.Components.Element.html#c:parse/1"},{"type":"module","title":"Idmlx.Components.Font","doc":"Represents a font in an InDesign document.\n\nThis module provides functionality for handling font definitions, including:\n- Font metadata management\n- URL and format settings\n- CSS generation for web output\n- Reference tracking for font usage","ref":"Idmlx.Components.Font.html"},{"type":"module","title":"Font Structure - Idmlx.Components.Font","doc":"* name - The font family name\n  * format - The font format (e.g., \"woff2\", \"ttf\")\n  * url - URL to the font resource\n  * style - Font style information\n  * references - List of places where the font is used","ref":"Idmlx.Components.Font.html#module-font-structure"},{"type":"module","title":"Examples - Idmlx.Components.Font","doc":"%Idmlx.Components.Font{\n      name: \"Helvetica\",\n      format: \"woff2\",\n      url: \"https://fonts.example.com/helvetica.woff2\",\n      style: \"Regular\",\n      references: [\"ParagraphStyle:Body\", \"Story:main\"]\n    }","ref":"Idmlx.Components.Font.html#module-examples"},{"type":"function","title":"Idmlx.Components.Font.add_reference/2","doc":"Adds a reference to a font's reference list.","ref":"Idmlx.Components.Font.html#add_reference/2"},{"type":"function","title":"Parameters - Idmlx.Components.Font.add_reference/2","doc":"- font: The font struct to update\n  - reference: The reference to add (e.g., \"ParagraphStyle:Body\")","ref":"Idmlx.Components.Font.html#add_reference/2-parameters"},{"type":"function","title":"Examples - Idmlx.Components.Font.add_reference/2","doc":"iex> font = %Idmlx.Components.Font{name: \"Helvetica\", references: [\"Story:main\"]}\n    iex> Idmlx.Components.Font.add_reference(font, \"ParagraphStyle:Body\")\n    %Idmlx.Components.Font{name: \"Helvetica\", references: [\"Story:main\", \"ParagraphStyle:Body\"]}","ref":"Idmlx.Components.Font.html#add_reference/2-examples"},{"type":"function","title":"Idmlx.Components.Font.set_format/2","doc":"Sets the format for a font.","ref":"Idmlx.Components.Font.html#set_format/2"},{"type":"function","title":"Parameters - Idmlx.Components.Font.set_format/2","doc":"- font: The font struct to update\n  - format: The format to set (e.g., \"woff2\", \"ttf\")","ref":"Idmlx.Components.Font.html#set_format/2-parameters"},{"type":"function","title":"Examples - Idmlx.Components.Font.set_format/2","doc":"iex> font = %Idmlx.Components.Font{name: \"Helvetica\"}\n    iex> Idmlx.Components.Font.set_format(font, \"woff2\")\n    %Idmlx.Components.Font{name: \"Helvetica\", format: \"woff2\"}","ref":"Idmlx.Components.Font.html#set_format/2-examples"},{"type":"function","title":"Idmlx.Components.Font.set_style/2","doc":"Sets the style for a font.","ref":"Idmlx.Components.Font.html#set_style/2"},{"type":"function","title":"Parameters - Idmlx.Components.Font.set_style/2","doc":"- font: The font struct to update\n  - style: The style to set (e.g., \"Regular\", \"Bold\")","ref":"Idmlx.Components.Font.html#set_style/2-parameters"},{"type":"function","title":"Examples - Idmlx.Components.Font.set_style/2","doc":"iex> font = %Idmlx.Components.Font{name: \"Helvetica\"}\n    iex> Idmlx.Components.Font.set_style(font, \"Bold\")\n    %Idmlx.Components.Font{name: \"Helvetica\", style: \"Bold\"}","ref":"Idmlx.Components.Font.html#set_style/2-examples"},{"type":"function","title":"Idmlx.Components.Font.set_url/2","doc":"Sets the URL for a font.","ref":"Idmlx.Components.Font.html#set_url/2"},{"type":"function","title":"Parameters - Idmlx.Components.Font.set_url/2","doc":"- font: The font struct to update\n  - url: The URL to set","ref":"Idmlx.Components.Font.html#set_url/2-parameters"},{"type":"function","title":"Examples - Idmlx.Components.Font.set_url/2","doc":"iex> font = %Idmlx.Components.Font{name: \"Helvetica\"}\n    iex> Idmlx.Components.Font.set_url(font, \"https://fonts.example.com/helvetica.woff2\")\n    %Idmlx.Components.Font{name: \"Helvetica\", url: \"https://fonts.example.com/helvetica.woff2\"}","ref":"Idmlx.Components.Font.html#set_url/2-examples"},{"type":"type","title":"Idmlx.Components.Font.t/0","doc":"","ref":"Idmlx.Components.Font.html#t:t/0"},{"type":"function","title":"Idmlx.Components.Font.to_css/1","doc":"Generates CSS @font-face declaration for the font.","ref":"Idmlx.Components.Font.html#to_css/1"},{"type":"function","title":"Parameters - Idmlx.Components.Font.to_css/1","doc":"- font: The font struct to generate CSS for","ref":"Idmlx.Components.Font.html#to_css/1-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Font.to_css/1","doc":"CSS @font-face declaration as a string","ref":"Idmlx.Components.Font.html#to_css/1-returns"},{"type":"function","title":"Examples - Idmlx.Components.Font.to_css/1","doc":"iex> font = %Idmlx.Components.Font{name: \"Helvetica\", url: \"fonts/helvetica.woff2\", format: \"woff2\"}\n    iex> Idmlx.Components.Font.to_css(font)\n    \"\"\"\n    @font-face {\n      font-family: Helvetica;\n      src: prince-lookup(\"Helvetica\"),\n          url(\"fonts/helvetica.woff2\") format(\"woff2\");\n    }\n    \"\"\"","ref":"Idmlx.Components.Font.html#to_css/1-examples"},{"type":"module","title":"Idmlx.Components.Fonts","doc":"Provides functionality for parsing and working with InDesign fonts.\n\nThis module handles:\n- Parsing fonts from IDMS/IDML files\n- Extracting fonts from various document elements (styles, stories)\n- Merging font definitions from different sources\n- Font lookup and management","ref":"Idmlx.Components.Fonts.html"},{"type":"module","title":"Font Sources - Idmlx.Components.Fonts","doc":"* Base fonts (FontFamily definitions)\n  * Paragraph style fonts\n  * Character style fonts\n  * Story fonts","ref":"Idmlx.Components.Fonts.html#module-font-sources"},{"type":"module","title":"Examples - Idmlx.Components.Fonts","doc":"# Get all fonts from a document\n    fonts = Idmlx.Components.Fonts.get_fonts(\"template.idms\")\n\n    # Find a specific font\n    helvetica = Idmlx.Components.Fonts.find_font_by_name(fonts, \"Helvetica\")","ref":"Idmlx.Components.Fonts.html#module-examples"},{"type":"function","title":"Idmlx.Components.Fonts.find_font_by_name/2","doc":"Finds a font by name in a list of fonts.","ref":"Idmlx.Components.Fonts.html#find_font_by_name/2"},{"type":"function","title":"Parameters - Idmlx.Components.Fonts.find_font_by_name/2","doc":"- fonts: List of Font structs to search\n  - name: Name of the font to find","ref":"Idmlx.Components.Fonts.html#find_font_by_name/2-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Fonts.find_font_by_name/2","doc":"Font struct or nil if not found","ref":"Idmlx.Components.Fonts.html#find_font_by_name/2-returns"},{"type":"function","title":"Examples - Idmlx.Components.Fonts.find_font_by_name/2","doc":"iex> fonts = [%Font{name: \"Helvetica\"}, %Font{name: \"Arial\"}]\n    iex> Idmlx.Components.Fonts.find_font_by_name(fonts, \"Helvetica\")\n    %Font{name: \"Helvetica\", ...}","ref":"Idmlx.Components.Fonts.html#find_font_by_name/2-examples"},{"type":"function","title":"Idmlx.Components.Fonts.get_fonts/1","doc":"Gets all fonts from an IDMS/IDML file, including those referenced in styles and stories.","ref":"Idmlx.Components.Fonts.html#get_fonts/1"},{"type":"function","title":"Parameters - Idmlx.Components.Fonts.get_fonts/1","doc":"- file_path: Path to the file to parse (defaults to \"Resources/Fonts.xml\")","ref":"Idmlx.Components.Fonts.html#get_fonts/1-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Fonts.get_fonts/1","doc":"List of unique Font structs with merged references","ref":"Idmlx.Components.Fonts.html#get_fonts/1-returns"},{"type":"function","title":"Examples - Idmlx.Components.Fonts.get_fonts/1","doc":"iex> Idmlx.Components.Fonts.get_fonts(\"template.idms\")\n    [%Idmlx.Components.Font{name: \"Helvetica\", references: [\"FontFamily\", \"Story:main\"], ...}]","ref":"Idmlx.Components.Fonts.html#get_fonts/1-examples"},{"type":"module","title":"Idmlx.Components.Layer","doc":"Represents a layer in an InDesign document.","ref":"Idmlx.Components.Layer.html"},{"type":"type","title":"Idmlx.Components.Layer.t/0","doc":"","ref":"Idmlx.Components.Layer.html#t:t/0"},{"type":"module","title":"Idmlx.Components.Layers","doc":"Provides functionality for parsing and working with InDesign layers.","ref":"Idmlx.Components.Layers.html"},{"type":"function","title":"Idmlx.Components.Layers.parse_layers/1","doc":"Parses layers from an IDMS file.","ref":"Idmlx.Components.Layers.html#parse_layers/1"},{"type":"module","title":"Idmlx.Components.Page","doc":"Represents a page in an InDesign document.\n\nThis module defines the structure for pages, including:\n- Geometric properties (bounds, transforms)\n- Spatial information (coordinates, aspect ratio)\n- Page orientation (face)\n- Page content (items)","ref":"Idmlx.Components.Page.html"},{"type":"module","title":"Page Structure - Idmlx.Components.Page","doc":"* aspect_ratio - Width to height ratio of the page\n  * geometric_bounds - Raw page boundaries [y1, x1, y2, x2]\n  * item_transform - Transformation matrix [a, b, c, d, tx, ty]\n  * coordinates - Calculated page coordinates after transformation\n  * face - Page orientation (\"RECTO\" or \"VERSO\")\n  * items - List of page elements (TextFrames, Rectangles, etc.)","ref":"Idmlx.Components.Page.html#module-page-structure"},{"type":"module","title":"Examples - Idmlx.Components.Page","doc":"%Idmlx.Components.Page{\n      aspect_ratio: 0.707,\n      geometric_bounds: [0.0, 0.0, 841.89, 595.28],\n      coordinates: %{\"x1\" => 0.0, \"y1\" => 0.0, \"x2\" => 595.28, \"y2\" => 841.89},\n      face: \"RECTO\",\n      items: [%TextFrame{}, %Rectangle{}]\n    }","ref":"Idmlx.Components.Page.html#module-examples"},{"type":"type","title":"Idmlx.Components.Page.coordinates/0","doc":"","ref":"Idmlx.Components.Page.html#t:coordinates/0"},{"type":"type","title":"Idmlx.Components.Page.t/0","doc":"","ref":"Idmlx.Components.Page.html#t:t/0"},{"type":"behaviour","title":"Idmlx.Components.Pages","doc":"Provides functionality for parsing and working with InDesign pages.\n\nThis module handles:\n- Page parsing from XML\n- Geometric calculations\n- Item placement and transformation\n- Page orientation determination","ref":"Idmlx.Components.Pages.html"},{"type":"behaviour","title":"Page Processing - Idmlx.Components.Pages","doc":"Pages are processed by:\n1. Extracting geometric bounds and transforms\n2. Calculating actual coordinates\n3. Determining page orientation\n4. Collecting and transforming page items","ref":"Idmlx.Components.Pages.html#module-page-processing"},{"type":"behaviour","title":"Coordinate System - Idmlx.Components.Pages","doc":"The coordinate system uses:\n- Origin at top-left\n- Positive X to the right\n- Positive Y downward\n- Units in points (1/72 inch)","ref":"Idmlx.Components.Pages.html#module-coordinate-system"},{"type":"function","title":"Idmlx.Components.Pages.element_is_in_page/2","doc":"Determines if an element is positioned within a page's boundaries.","ref":"Idmlx.Components.Pages.html#element_is_in_page/2"},{"type":"function","title":"Parameters - Idmlx.Components.Pages.element_is_in_page/2","doc":"- element: The element to check\n  - coordinates: The page coordinates to check against","ref":"Idmlx.Components.Pages.html#element_is_in_page/2-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Pages.element_is_in_page/2","doc":"Boolean indicating if the element is within the page","ref":"Idmlx.Components.Pages.html#element_is_in_page/2-returns"},{"type":"function","title":"Examples - Idmlx.Components.Pages.element_is_in_page/2","doc":"iex> element = get_element()\n    iex> coordinates = %{\"x1\" => 0.0, \"x2\" => 595.28}\n    iex> Idmlx.Components.Pages.element_is_in_page(element, coordinates)\n    true","ref":"Idmlx.Components.Pages.html#element_is_in_page/2-examples"},{"type":"function","title":"Idmlx.Components.Pages.parse_page/1","doc":"Parses a page from an XML fragment.\n\nProcesses the page geometry, transforms, and content to create a complete\npage representation.","ref":"Idmlx.Components.Pages.html#parse_page/1"},{"type":"function","title":"Parameters - Idmlx.Components.Pages.parse_page/1","doc":"- xml_fragment: XML fragment containing page data","ref":"Idmlx.Components.Pages.html#parse_page/1-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Pages.parse_page/1","doc":"A Page struct with all calculated properties","ref":"Idmlx.Components.Pages.html#parse_page/1-returns"},{"type":"function","title":"Examples - Idmlx.Components.Pages.parse_page/1","doc":"iex> xml = get_page_xml()\n    iex> Idmlx.Components.Pages.parse_page(xml)\n    %Page{\n      geometric_bounds: [0.0, 0.0, 841.89, 595.28],\n      face: \"RECTO\",\n      items: [%TextFrame{}, %Rectangle{}]\n    }","ref":"Idmlx.Components.Pages.html#parse_page/1-examples"},{"type":"callback","title":"Idmlx.Components.Pages.parse_page/1","doc":"","ref":"Idmlx.Components.Pages.html#c:parse_page/1"},{"type":"module","title":"Idmlx.Components.Polygon","doc":"Represents a polygon in an InDesign document.\n\nThis module provides functionality for handling polygon elements, including:\n- Geometric properties (points, coordinates, dimensions)\n- Layer information\n- Style attributes\n- Transformation data","ref":"Idmlx.Components.Polygon.html"},{"type":"module","title":"Polygon Structure - Idmlx.Components.Polygon","doc":"* name - Unique identifier for the polygon\n  * layer - Layer containing the polygon\n  * content_type - Type of content (e.g., \"GraphicType\")\n  * coordinates - Bounding box coordinates\n  * item_transform - Transformation matrix [a, b, c, d, tx, ty]\n  * points - List of polygon vertices after transformation\n  * dimensions - Width and height of the bounding box\n  * object_style - Applied object style reference\n  * draggable - Whether the polygon can be dragged\n  * attributes - Raw XML attributes","ref":"Idmlx.Components.Polygon.html#module-polygon-structure"},{"type":"module","title":"Examples - Idmlx.Components.Polygon","doc":"%Idmlx.Components.Polygon{\n      name: \"polygon_1\",\n      content_type: \"GraphicType\",\n      points: [[0.0, 0.0], [100.0, 0.0], [100.0, 100.0], [0.0, 100.0]],\n      coordinates: %{\"x1\" => 0.0, \"y1\" => 0.0, \"x2\" => 100.0, \"y2\" => 100.0},\n      dimensions: %{\"width\" => 100.0, \"height\" => 100.0}\n    }","ref":"Idmlx.Components.Polygon.html#module-examples"},{"type":"type","title":"Idmlx.Components.Polygon.coordinates/0","doc":"","ref":"Idmlx.Components.Polygon.html#t:coordinates/0"},{"type":"type","title":"Idmlx.Components.Polygon.dimensions/0","doc":"","ref":"Idmlx.Components.Polygon.html#t:dimensions/0"},{"type":"function","title":"Idmlx.Components.Polygon.parse/3","doc":"Parses a polygon element from an XML fragment.\n\nProcesses the polygon geometry, transforms, and attributes to create a complete\npolygon representation.","ref":"Idmlx.Components.Polygon.html#parse/3"},{"type":"function","title":"Parameters - Idmlx.Components.Polygon.parse/3","doc":"- xml_fragment: XML fragment containing polygon data\n  - layer: Optional layer information\n  - _story: Optional story reference (unused for polygons)","ref":"Idmlx.Components.Polygon.html#parse/3-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Polygon.parse/3","doc":"A Polygon struct with calculated properties","ref":"Idmlx.Components.Polygon.html#parse/3-returns"},{"type":"function","title":"Examples - Idmlx.Components.Polygon.parse/3","doc":"iex> xml = get_polygon_xml()\n    iex> Idmlx.Components.Polygon.parse(xml)\n    %Polygon{\n      name: \"polygon_1\",\n      content_type: \"GraphicType\",\n      points: [[0.0, 0.0], [100.0, 0.0], [100.0, 100.0], [0.0, 100.0]]\n    }","ref":"Idmlx.Components.Polygon.html#parse/3-examples"},{"type":"type","title":"Idmlx.Components.Polygon.point/0","doc":"","ref":"Idmlx.Components.Polygon.html#t:point/0"},{"type":"type","title":"Idmlx.Components.Polygon.t/0","doc":"","ref":"Idmlx.Components.Polygon.html#t:t/0"},{"type":"module","title":"Idmlx.Components.Rectangle","doc":"Represents a rectangle shape in an InDesign document.\n\nThis module provides functionality for handling rectangular elements, including:\n- Geometric properties (coordinates, dimensions)\n- Layer information\n- Style attributes\n- HTML conversion capabilities","ref":"Idmlx.Components.Rectangle.html"},{"type":"module","title":"Rectangle Structure - Idmlx.Components.Rectangle","doc":"* name - Unique identifier for the rectangle\n  * layer - Layer containing the rectangle\n  * content_type - Type of content (e.g., \"GraphicType\")\n  * coordinates - Bounding box coordinates\n  * item_transform - Transformation matrix [a, b, c, d, tx, ty]\n  * dimensions - Width and height of the rectangle\n  * object_style - Applied object style reference\n  * draggable - Whether the rectangle can be dragged\n  * attributes - Raw XML attributes","ref":"Idmlx.Components.Rectangle.html#module-rectangle-structure"},{"type":"module","title":"Examples - Idmlx.Components.Rectangle","doc":"%Idmlx.Components.Rectangle{\n      name: \"rect_1\",\n      content_type: \"GraphicType\",\n      coordinates: %{\"x1\" => 0.0, \"y1\" => 0.0, \"x2\" => 100.0, \"y2\" => 100.0},\n      dimensions: %{\"width\" => 100.0, \"height\" => 100.0}\n    }","ref":"Idmlx.Components.Rectangle.html#module-examples"},{"type":"type","title":"Idmlx.Components.Rectangle.coordinates/0","doc":"","ref":"Idmlx.Components.Rectangle.html#t:coordinates/0"},{"type":"type","title":"Idmlx.Components.Rectangle.dimensions/0","doc":"","ref":"Idmlx.Components.Rectangle.html#t:dimensions/0"},{"type":"function","title":"Idmlx.Components.Rectangle.parse/3","doc":"Parses a rectangle element from an XML fragment.\n\nProcesses the rectangle geometry, transforms, and attributes to create a complete\nrectangle representation.","ref":"Idmlx.Components.Rectangle.html#parse/3"},{"type":"function","title":"Parameters - Idmlx.Components.Rectangle.parse/3","doc":"- xml_fragment: XML fragment containing rectangle data\n  - layer: Optional layer information\n  - _story: Optional story reference (unused for rectangles)","ref":"Idmlx.Components.Rectangle.html#parse/3-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Rectangle.parse/3","doc":"A Rectangle struct with calculated properties","ref":"Idmlx.Components.Rectangle.html#parse/3-returns"},{"type":"function","title":"Examples - Idmlx.Components.Rectangle.parse/3","doc":"iex> xml = get_rectangle_xml()\n    iex> Idmlx.Components.Rectangle.parse(xml)\n    %Rectangle{\n      name: \"rect_1\",\n      content_type: \"GraphicType\",\n      coordinates: %{\"x1\" => 0.0, \"y1\" => 0.0, \"x2\" => 100.0, \"y2\" => 100.0}\n    }","ref":"Idmlx.Components.Rectangle.html#parse/3-examples"},{"type":"type","title":"Idmlx.Components.Rectangle.t/0","doc":"","ref":"Idmlx.Components.Rectangle.html#t:t/0"},{"type":"function","title":"Idmlx.Components.Rectangle.to_html/3","doc":"Converts a rectangle to HTML representation.\n\nCreates an HTML img element with appropriate styling and positioning based on\nthe rectangle's properties and object style.","ref":"Idmlx.Components.Rectangle.html#to_html/3"},{"type":"function","title":"Parameters - Idmlx.Components.Rectangle.to_html/3","doc":"- rectangle: The Rectangle struct to convert\n  - assign: Map of assignments including 'src' for the image source\n  - _mode: Rendering mode (unused)","ref":"Idmlx.Components.Rectangle.html#to_html/3-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Rectangle.to_html/3","doc":"HTML string representation of the rectangle as an img element, or nil if no src","ref":"Idmlx.Components.Rectangle.html#to_html/3-returns"},{"type":"function","title":"Examples - Idmlx.Components.Rectangle.to_html/3","doc":"iex> rect = %Rectangle{name: \"rect_1\", content_type: \"GraphicType\"}\n    iex> Rectangle.to_html(rect, %{\"src\" => \"image.jpg\"}, :filled)\n    \"\"\"\n     \n    \"\"\"","ref":"Idmlx.Components.Rectangle.html#to_html/3-examples"},{"type":"module","title":"Idmlx.Components.Spread","doc":"Represents a spread in an InDesign document.\n\nA spread is a pair of facing pages or a single page in an InDesign document.\nThis module defines the structure for storing spread information including:\n- Geometric boundaries\n- Associated styles\n- Page items (TextFrames, Rectangles, etc.)\n- Fonts and colors used in the spread","ref":"Idmlx.Components.Spread.html"},{"type":"module","title":"Spread Structure - Idmlx.Components.Spread","doc":"* geometric_bounds - Boundaries of the spread [y1, x1, y2, x2]\n  * styles - List of styles applied to elements in the spread\n  * items - List of page items (TextFrames, Rectangles, Polygons)\n  * fonts - List of fonts used in the spread\n  * colors - List of colors used in the spread","ref":"Idmlx.Components.Spread.html#module-spread-structure"},{"type":"module","title":"Examples - Idmlx.Components.Spread","doc":"%Idmlx.Components.Spread{\n      geometric_bounds: [0, 0, 841.89, 595.28],\n      items: [%TextFrame{}, %Rectangle{}],\n      styles: [%Style{}],\n      fonts: [%Font{}],\n      colors: [%Color{}]\n    }","ref":"Idmlx.Components.Spread.html#module-examples"},{"type":"type","title":"Idmlx.Components.Spread.t/0","doc":"","ref":"Idmlx.Components.Spread.html#t:t/0"},{"type":"behaviour","title":"Idmlx.Components.Spreads","doc":"Provides functionality for parsing and working with InDesign spreads.\n\nThis module handles:\n- Parsing spreads from IDMS/IDML files\n- Extracting geometric bounds\n- Processing page items\n- Managing spread collections","ref":"Idmlx.Components.Spreads.html"},{"type":"behaviour","title":"Spread Processing - Idmlx.Components.Spreads","doc":"Spreads are processed by:\n1. Reading spread files from disk\n2. Parsing XML content\n3. Calculating geometric bounds\n4. Processing page items with their layers and stories\n5. Assembling the final spread structure","ref":"Idmlx.Components.Spreads.html#module-spread-processing"},{"type":"behaviour","title":"File Support - Idmlx.Components.Spreads","doc":"Supports both:\n- IDMS (InDesign Markup Snippet) files\n- Individual spread files from IDML packages","ref":"Idmlx.Components.Spreads.html#module-file-support"},{"type":"function","title":"Idmlx.Components.Spreads.get_spreads/1","doc":"Gets all spreads from a directory of spread files.","ref":"Idmlx.Components.Spreads.html#get_spreads/1"},{"type":"function","title":"Parameters - Idmlx.Components.Spreads.get_spreads/1","doc":"- path: Path to the directory containing spread files (defaults to \"Spreads\")","ref":"Idmlx.Components.Spreads.html#get_spreads/1-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Spreads.get_spreads/1","doc":"List of parsed Spread structs","ref":"Idmlx.Components.Spreads.html#get_spreads/1-returns"},{"type":"function","title":"Examples - Idmlx.Components.Spreads.get_spreads/1","doc":"iex> Idmlx.Components.Spreads.get_spreads(\"./example/Spreads\")\n    [%Spread{geometric_bounds: [0, 0, 841.89, 595.28], items: [...]}, ...]","ref":"Idmlx.Components.Spreads.html#get_spreads/1-examples"},{"type":"callback","title":"Idmlx.Components.Spreads.get_spreads/1","doc":"","ref":"Idmlx.Components.Spreads.html#c:get_spreads/1"},{"type":"callback","title":"Idmlx.Components.Spreads.parse_spread/2","doc":"","ref":"Idmlx.Components.Spreads.html#c:parse_spread/2"},{"type":"function","title":"Idmlx.Components.Spreads.parse_spread/3","doc":"Parses a spread from a file.\n\nHandles both IDMS files and individual spread files from IDML packages.","ref":"Idmlx.Components.Spreads.html#parse_spread/3"},{"type":"function","title":"Parameters - Idmlx.Components.Spreads.parse_spread/3","doc":"- file_path: Path to the spread file\n  - layers: Optional list of layers\n  - stories: Optional list of stories","ref":"Idmlx.Components.Spreads.html#parse_spread/3-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Spreads.parse_spread/3","doc":"A parsed Spread struct","ref":"Idmlx.Components.Spreads.html#parse_spread/3-returns"},{"type":"function","title":"Examples - Idmlx.Components.Spreads.parse_spread/3","doc":"iex> Idmlx.Components.Spreads.parse_spread(\"spread.idms\")\n    %Spread{\n      geometric_bounds: [0, 0, 841.89, 595.28],\n      items: [%TextFrame{}, %Rectangle{}]\n    }","ref":"Idmlx.Components.Spreads.html#parse_spread/3-examples"},{"type":"behaviour","title":"Idmlx.Components.Stories","doc":"Provides functionality for parsing and working with InDesign stories.","ref":"Idmlx.Components.Stories.html"},{"type":"function","title":"Idmlx.Components.Stories.get_stories/1","doc":"","ref":"Idmlx.Components.Stories.html#get_stories/1"},{"type":"callback","title":"Idmlx.Components.Stories.get_stories/1","doc":"","ref":"Idmlx.Components.Stories.html#c:get_stories/1"},{"type":"function","title":"Idmlx.Components.Stories.parse_stories/1","doc":"","ref":"Idmlx.Components.Stories.html#parse_stories/1"},{"type":"callback","title":"Idmlx.Components.Stories.parse_stories/1","doc":"","ref":"Idmlx.Components.Stories.html#c:parse_stories/1"},{"type":"module","title":"Idmlx.Components.Story","doc":"Represents a story (text content) in an InDesign document.","ref":"Idmlx.Components.Story.html"},{"type":"function","title":"Idmlx.Components.Story.get_style_overrides/1","doc":"","ref":"Idmlx.Components.Story.html#get_style_overrides/1"},{"type":"module","title":"Idmlx.Components.Style","doc":"Represents a style in an InDesign document.\n\nThis module provides functionality for handling and manipulating InDesign styles, including:\n- Font and text formatting\n- Color management\n- Style inheritance\n- CSS conversion","ref":"Idmlx.Components.Style.html"},{"type":"module","title":"Style Structure - Idmlx.Components.Style","doc":"* name - Full style identifier (e.g., \"ParagraphStyle/Body\")\n  * applied_font - Font information for the style\n  * attributes - List of style attributes and their values\n  * based_on - Parent style reference for inheritance","ref":"Idmlx.Components.Style.html#module-style-structure"},{"type":"module","title":"Style Types - Idmlx.Components.Style","doc":"Supports three main types of styles:\n- Paragraph styles\n- Character styles\n- Object styles","ref":"Idmlx.Components.Style.html#module-style-types"},{"type":"module","title":"Examples - Idmlx.Components.Style","doc":"%Idmlx.Components.Style{\n      name: \"ParagraphStyle/Body\",\n      applied_font: %Font{name: \"Helvetica\"},\n      attributes: [%{key: :PointSize, value: \"12\"}],\n      based_on: \"ParagraphStyle/$ID/[No paragraph style]\"\n    }","ref":"Idmlx.Components.Style.html#module-examples"},{"type":"type","title":"Idmlx.Components.Style.attribute/0","doc":"","ref":"Idmlx.Components.Style.html#t:attribute/0"},{"type":"function","title":"Idmlx.Components.Style.format_font_style/3","doc":"Formats the font style (weight/italic) based on InDesign font style.","ref":"Idmlx.Components.Style.html#format_font_style/3"},{"type":"function","title":"Parameters - Idmlx.Components.Style.format_font_style/3","doc":"- style: The style to format\n  - overrides: Map of style overrides\n  - styles: List of all styles for inheritance lookup","ref":"Idmlx.Components.Style.html#format_font_style/3-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Style.format_font_style/3","doc":"CSS font-style or font-weight value","ref":"Idmlx.Components.Style.html#format_font_style/3-returns"},{"type":"function","title":"Examples - Idmlx.Components.Style.format_font_style/3","doc":"iex> style = %Style{attributes: [%{key: :FontStyle, value: \"Bold Italic\"}]}\n    iex> Style.format_font_style(style)\n    \"italic\"","ref":"Idmlx.Components.Style.html#format_font_style/3-examples"},{"type":"function","title":"Idmlx.Components.Style.format_hyphenation/3","doc":"Formats hyphenation setting based on InDesign hyphenation value.","ref":"Idmlx.Components.Style.html#format_hyphenation/3"},{"type":"function","title":"Parameters - Idmlx.Components.Style.format_hyphenation/3","doc":"- style: The style to format\n  - overrides: Map of style overrides\n  - styles: List of all styles for inheritance lookup","ref":"Idmlx.Components.Style.html#format_hyphenation/3-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Style.format_hyphenation/3","doc":"CSS word-break value","ref":"Idmlx.Components.Style.html#format_hyphenation/3-returns"},{"type":"function","title":"Idmlx.Components.Style.format_letter_spacing/3","doc":"Formats letter spacing based on InDesign tracking value.","ref":"Idmlx.Components.Style.html#format_letter_spacing/3"},{"type":"function","title":"Parameters - Idmlx.Components.Style.format_letter_spacing/3","doc":"- style: The style to format\n  - overrides: Map of style overrides\n  - styles: List of all styles for inheritance lookup","ref":"Idmlx.Components.Style.html#format_letter_spacing/3-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Style.format_letter_spacing/3","doc":"CSS letter-spacing value in pixels","ref":"Idmlx.Components.Style.html#format_letter_spacing/3-returns"},{"type":"function","title":"Idmlx.Components.Style.format_text_align/3","doc":"Formats text alignment based on InDesign justification.","ref":"Idmlx.Components.Style.html#format_text_align/3"},{"type":"function","title":"Parameters - Idmlx.Components.Style.format_text_align/3","doc":"- style: The style to format\n  - overrides: Map of style overrides\n  - styles: List of all styles for inheritance lookup","ref":"Idmlx.Components.Style.html#format_text_align/3-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Style.format_text_align/3","doc":"CSS text-align value","ref":"Idmlx.Components.Style.html#format_text_align/3-returns"},{"type":"function","title":"Examples - Idmlx.Components.Style.format_text_align/3","doc":"iex> style = %Style{attributes: [%{key: :Justification, value: \"CenterAlign\"}]}\n    iex> Style.format_text_align(style)\n    \"center\"","ref":"Idmlx.Components.Style.html#format_text_align/3-examples"},{"type":"function","title":"Idmlx.Components.Style.format_vertical_align/3","doc":"Formats vertical alignment based on InDesign vertical justification.","ref":"Idmlx.Components.Style.html#format_vertical_align/3"},{"type":"function","title":"Parameters - Idmlx.Components.Style.format_vertical_align/3","doc":"- style: The style to format\n  - overrides: Map of style overrides\n  - styles: List of all styles for inheritance lookup","ref":"Idmlx.Components.Style.html#format_vertical_align/3-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Style.format_vertical_align/3","doc":"CSS vertical-align value","ref":"Idmlx.Components.Style.html#format_vertical_align/3-returns"},{"type":"function","title":"Idmlx.Components.Style.get_attribute_value/4","doc":"Gets an attribute value, considering overrides and inheritance.","ref":"Idmlx.Components.Style.html#get_attribute_value/4"},{"type":"function","title":"Parameters - Idmlx.Components.Style.get_attribute_value/4","doc":"- style: The style to get the value from\n  - key: Attribute key to look up\n  - overrides: Map of style overrides\n  - styles: List of all styles for inheritance lookup","ref":"Idmlx.Components.Style.html#get_attribute_value/4-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Style.get_attribute_value/4","doc":"Attribute value or nil if not found","ref":"Idmlx.Components.Style.html#get_attribute_value/4-returns"},{"type":"function","title":"Idmlx.Components.Style.get_fill_color/4","doc":"Gets fill color for a style, considering tint.","ref":"Idmlx.Components.Style.html#get_fill_color/4"},{"type":"function","title":"Parameters - Idmlx.Components.Style.get_fill_color/4","doc":"- style: The style to get the color from\n  - colors: List of available colors\n  - overrides: Map of style overrides\n  - styles: List of all styles for inheritance lookup","ref":"Idmlx.Components.Style.html#get_fill_color/4-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Style.get_fill_color/4","doc":"CSS color value","ref":"Idmlx.Components.Style.html#get_fill_color/4-returns"},{"type":"function","title":"Idmlx.Components.Style.get_font_family/3","doc":"Gets the font family for a style, considering overrides and inheritance.","ref":"Idmlx.Components.Style.html#get_font_family/3"},{"type":"function","title":"Parameters - Idmlx.Components.Style.get_font_family/3","doc":"- style: The style to get the font family from\n  - overrides: Map of style overrides\n  - styles: List of all styles for inheritance lookup","ref":"Idmlx.Components.Style.html#get_font_family/3-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Style.get_font_family/3","doc":"Font family name as string, defaults to \"Arial\"","ref":"Idmlx.Components.Style.html#get_font_family/3-returns"},{"type":"function","title":"Examples - Idmlx.Components.Style.get_font_family/3","doc":"iex> style = %Style{applied_font: %Font{name: \"Helvetica\"}}\n    iex> Style.get_font_family(style)\n    \"Helvetica\"","ref":"Idmlx.Components.Style.html#get_font_family/3-examples"},{"type":"function","title":"Idmlx.Components.Style.get_stroke_color/4","doc":"Gets stroke color for a style, considering tint.","ref":"Idmlx.Components.Style.html#get_stroke_color/4"},{"type":"function","title":"Parameters - Idmlx.Components.Style.get_stroke_color/4","doc":"- style: The style to get the color from\n  - colors: List of available colors\n  - overrides: Map of style overrides\n  - styles: List of all styles for inheritance lookup","ref":"Idmlx.Components.Style.html#get_stroke_color/4-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Style.get_stroke_color/4","doc":"CSS color value or nil","ref":"Idmlx.Components.Style.html#get_stroke_color/4-returns"},{"type":"type","title":"Idmlx.Components.Style.t/0","doc":"","ref":"Idmlx.Components.Style.html#t:t/0"},{"type":"function","title":"Idmlx.Components.Style.to_css/2","doc":"Converts a style to CSS.","ref":"Idmlx.Components.Style.html#to_css/2"},{"type":"function","title":"Parameters - Idmlx.Components.Style.to_css/2","doc":"- style: The style to convert\n  - styles: List of all styles for inheritance lookup","ref":"Idmlx.Components.Style.html#to_css/2-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Style.to_css/2","doc":"CSS rules as string","ref":"Idmlx.Components.Style.html#to_css/2-returns"},{"type":"function","title":"Examples - Idmlx.Components.Style.to_css/2","doc":"iex> style = %Style{name: \"ParagraphStyle/Body\"}\n    iex> Style.to_css(style)\n    \"\"\".Body {\n      font-size: 10px;\n      ...\n    }\"\"\"","ref":"Idmlx.Components.Style.html#to_css/2-examples"},{"type":"behaviour","title":"Idmlx.Components.Styles","doc":"Provides functionality for parsing and working with InDesign styles.\n\nThis module handles:\n- Parsing styles from IDMS/IDML files\n- Managing different style types\n- Style inheritance resolution\n- Style collection management","ref":"Idmlx.Components.Styles.html"},{"type":"behaviour","title":"Style Types - Idmlx.Components.Styles","doc":"Supports three main categories:\n- Paragraph styles (text formatting)\n- Character styles (character-level formatting)\n- Object styles (shape and frame formatting)","ref":"Idmlx.Components.Styles.html#module-style-types"},{"type":"behaviour","title":"Style Inheritance - Idmlx.Components.Styles","doc":"Styles can inherit properties from parent styles using the `based_on` field.\nThe module handles resolving inherited properties through the style hierarchy.","ref":"Idmlx.Components.Styles.html#module-style-inheritance"},{"type":"function","title":"Idmlx.Components.Styles.get_character_styles/1","doc":"Gets character styles from a file.","ref":"Idmlx.Components.Styles.html#get_character_styles/1"},{"type":"function","title":"Parameters - Idmlx.Components.Styles.get_character_styles/1","doc":"- file_path: Path to the styles file (defaults to \"Resources/Styles.xml\")","ref":"Idmlx.Components.Styles.html#get_character_styles/1-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Styles.get_character_styles/1","doc":"List of character styles","ref":"Idmlx.Components.Styles.html#get_character_styles/1-returns"},{"type":"callback","title":"Idmlx.Components.Styles.get_character_styles/1","doc":"","ref":"Idmlx.Components.Styles.html#c:get_character_styles/1"},{"type":"function","title":"Idmlx.Components.Styles.get_object_styles/1","doc":"Gets object styles from a file.","ref":"Idmlx.Components.Styles.html#get_object_styles/1"},{"type":"function","title":"Parameters - Idmlx.Components.Styles.get_object_styles/1","doc":"- file_path: Path to the styles file (defaults to \"Resources/Styles.xml\")","ref":"Idmlx.Components.Styles.html#get_object_styles/1-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Styles.get_object_styles/1","doc":"List of object styles","ref":"Idmlx.Components.Styles.html#get_object_styles/1-returns"},{"type":"callback","title":"Idmlx.Components.Styles.get_object_styles/1","doc":"","ref":"Idmlx.Components.Styles.html#c:get_object_styles/1"},{"type":"function","title":"Idmlx.Components.Styles.get_paragraph_styles/1","doc":"Gets paragraph styles from a file.","ref":"Idmlx.Components.Styles.html#get_paragraph_styles/1"},{"type":"function","title":"Parameters - Idmlx.Components.Styles.get_paragraph_styles/1","doc":"- file_path: Path to the styles file (defaults to \"Resources/Styles.xml\")","ref":"Idmlx.Components.Styles.html#get_paragraph_styles/1-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Styles.get_paragraph_styles/1","doc":"List of paragraph styles","ref":"Idmlx.Components.Styles.html#get_paragraph_styles/1-returns"},{"type":"callback","title":"Idmlx.Components.Styles.get_paragraph_styles/1","doc":"","ref":"Idmlx.Components.Styles.html#c:get_paragraph_styles/1"},{"type":"function","title":"Idmlx.Components.Styles.get_styles/1","doc":"Gets all styles from a file.","ref":"Idmlx.Components.Styles.html#get_styles/1"},{"type":"function","title":"Parameters - Idmlx.Components.Styles.get_styles/1","doc":"- file_path: Path to the styles file (defaults to \"Resources/Styles.xml\")","ref":"Idmlx.Components.Styles.html#get_styles/1-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Styles.get_styles/1","doc":"List of all styles (paragraph, character, and object styles)","ref":"Idmlx.Components.Styles.html#get_styles/1-returns"},{"type":"function","title":"Examples - Idmlx.Components.Styles.get_styles/1","doc":"iex> Idmlx.Components.Styles.get_styles(\"styles.xml\")\n    [%Style{name: \"ParagraphStyle/Body\"}, %Style{name: \"CharacterStyle/Bold\"}]","ref":"Idmlx.Components.Styles.html#get_styles/1-examples"},{"type":"callback","title":"Idmlx.Components.Styles.get_styles/1","doc":"","ref":"Idmlx.Components.Styles.html#c:get_styles/1"},{"type":"module","title":"Idmlx.Components.Tag","doc":"Represents a tag in an InDesign document.\n\nTags are XML markup elements used in InDesign for content structuring and identification.\nThey provide a way to mark up content with semantic meaning and can be used for:\n- Content identification\n- XML export/import\n- Automated workflows\n- Document structure definition","ref":"Idmlx.Components.Tag.html"},{"type":"module","title":"Tag Structure - Idmlx.Components.Tag","doc":"* name - The identifier of the tag (e.g., \"Article\", \"Section\", \"Heading\")","ref":"Idmlx.Components.Tag.html#module-tag-structure"},{"type":"module","title":"Examples - Idmlx.Components.Tag","doc":"%Idmlx.Components.Tag{\n      name: \"Article\"\n    }","ref":"Idmlx.Components.Tag.html#module-examples"},{"type":"type","title":"Idmlx.Components.Tag.t/0","doc":"","ref":"Idmlx.Components.Tag.html#t:t/0"},{"type":"behaviour","title":"Idmlx.Components.Tags","doc":"Provides functionality for parsing and working with InDesign XML tags.\n\nThis module handles:\n- Parsing tags from IDMS/IDML files\n- Managing tag collections\n- XML tag extraction and processing","ref":"Idmlx.Components.Tags.html"},{"type":"behaviour","title":"Tag Processing - Idmlx.Components.Tags","doc":"Tags are processed from the XML/Tags.xml file in IDML packages\nor from the corresponding section in IDMS files.","ref":"Idmlx.Components.Tags.html#module-tag-processing"},{"type":"behaviour","title":"Usage - Idmlx.Components.Tags","doc":"Tags are typically used for:\n- XML structure definition\n- Content markup\n- Export/import workflows\n- Document organization","ref":"Idmlx.Components.Tags.html#module-usage"},{"type":"function","title":"Idmlx.Components.Tags.get_tags/1","doc":"Gets all XML tags from a file.","ref":"Idmlx.Components.Tags.html#get_tags/1"},{"type":"function","title":"Parameters - Idmlx.Components.Tags.get_tags/1","doc":"- file_path: Path to the tags file (defaults to \"XML/Tags.xml\")","ref":"Idmlx.Components.Tags.html#get_tags/1-parameters"},{"type":"function","title":"Returns - Idmlx.Components.Tags.get_tags/1","doc":"List of Tag structs","ref":"Idmlx.Components.Tags.html#get_tags/1-returns"},{"type":"function","title":"Examples - Idmlx.Components.Tags.get_tags/1","doc":"iex> Idmlx.Components.Tags.get_tags(\"XML/Tags.xml\")\n    [%Tag{name: \"Article\"}, %Tag{name: \"Section\"}]","ref":"Idmlx.Components.Tags.html#get_tags/1-examples"},{"type":"callback","title":"Idmlx.Components.Tags.get_tags/1","doc":"","ref":"Idmlx.Components.Tags.html#c:get_tags/1"},{"type":"module","title":"Idmlx.Components.TextFrame","doc":"Represents a text frame in an InDesign document.\n\nThis module provides functionality for handling text frames, including:\n- Content management\n- Style application\n- Geometric properties\n- HTML conversion\n- Layout preferences","ref":"Idmlx.Components.TextFrame.html"},{"type":"module","title":"Text Frame Structure - Idmlx.Components.TextFrame","doc":"* name - Unique identifier for the text frame\n  * layer - Layer containing the text frame\n  * content - Text content from associated story\n  * content_type - Type of content (e.g., \"TextType\")\n  * object_style - Applied object style reference\n  * paragraph_style - Applied paragraph style reference\n  * item_transform - Transformation matrix [a, b, c, d, tx, ty]\n  * coordinates - Bounding box coordinates\n  * dimensions - Width and height\n  * editable - Whether the frame is editable\n  * attributes - Raw XML attributes\n  * preferences - Text frame preferences\n  * story - Associated story content","ref":"Idmlx.Components.TextFrame.html#module-text-frame-structure"},{"type":"module","title":"Examples - Idmlx.Components.TextFrame","doc":"%Idmlx.Components.TextFrame{\n      name: \"text_frame_1\",\n      content_type: \"TextType\",\n      coordinates: %{\"x1\" => 0.0, \"y1\" => 0.0, \"x2\" => 200.0, \"y2\" => 100.0},\n      dimensions: %{\"width\" => 200.0, \"height\" => 100.0},\n      content: \"Sample text content\"\n    }","ref":"Idmlx.Components.TextFrame.html#module-examples"},{"type":"type","title":"Idmlx.Components.TextFrame.coordinates/0","doc":"","ref":"Idmlx.Components.TextFrame.html#t:coordinates/0"},{"type":"type","title":"Idmlx.Components.TextFrame.dimensions/0","doc":"","ref":"Idmlx.Components.TextFrame.html#t:dimensions/0"},{"type":"function","title":"Idmlx.Components.TextFrame.get_text_frame_preferences/1","doc":"Gets text frame preferences from XML.","ref":"Idmlx.Components.TextFrame.html#get_text_frame_preferences/1"},{"type":"function","title":"Parameters - Idmlx.Components.TextFrame.get_text_frame_preferences/1","doc":"- xml_fragment: XML fragment containing preferences","ref":"Idmlx.Components.TextFrame.html#get_text_frame_preferences/1-parameters"},{"type":"function","title":"Returns - Idmlx.Components.TextFrame.get_text_frame_preferences/1","doc":"List of preference attributes","ref":"Idmlx.Components.TextFrame.html#get_text_frame_preferences/1-returns"},{"type":"function","title":"Idmlx.Components.TextFrame.parse/3","doc":"Parses a text frame element from an XML fragment.\n\nProcesses the text frame geometry, content, and attributes to create a complete\ntext frame representation.","ref":"Idmlx.Components.TextFrame.html#parse/3"},{"type":"function","title":"Parameters - Idmlx.Components.TextFrame.parse/3","doc":"- xml_fragment: XML fragment containing text frame data\n  - layer: Optional layer information\n  - story: Optional associated story content","ref":"Idmlx.Components.TextFrame.html#parse/3-parameters"},{"type":"function","title":"Returns - Idmlx.Components.TextFrame.parse/3","doc":"A TextFrame struct with calculated properties","ref":"Idmlx.Components.TextFrame.html#parse/3-returns"},{"type":"function","title":"Examples - Idmlx.Components.TextFrame.parse/3","doc":"iex> xml = get_text_frame_xml()\n    iex> TextFrame.parse(xml)\n    %TextFrame{\n      name: \"text_frame_1\",\n      content_type: \"TextType\",\n      coordinates: %{\"x1\" => 0.0, \"y1\" => 0.0, \"x2\" => 200.0, \"y2\" => 100.0}\n    }","ref":"Idmlx.Components.TextFrame.html#parse/3-examples"},{"type":"type","title":"Idmlx.Components.TextFrame.t/0","doc":"","ref":"Idmlx.Components.TextFrame.html#t:t/0"},{"type":"function","title":"Idmlx.Components.TextFrame.to_html/3","doc":"Converts a text frame to HTML representation.\n\nCreates an HTML div element with appropriate styling and positioning based on\nthe text frame's properties and styles.","ref":"Idmlx.Components.TextFrame.html#to_html/3"},{"type":"function","title":"Parameters - Idmlx.Components.TextFrame.to_html/3","doc":"- element: The TextFrame struct to convert\n  - assigned_content: Optional content override\n  - mode: Rendering mode","ref":"Idmlx.Components.TextFrame.html#to_html/3-parameters"},{"type":"function","title":"Returns - Idmlx.Components.TextFrame.to_html/3","doc":"HTML string representation of the text frame","ref":"Idmlx.Components.TextFrame.html#to_html/3-returns"},{"type":"function","title":"Examples - Idmlx.Components.TextFrame.to_html/3","doc":"iex> frame = %TextFrame{content: \"Hello\", coordinates: %{\"x1\" => 0, \"y1\" => 0}}\n    iex> TextFrame.to_html(frame, nil, :filled)\n    \"\"\"\n     \n      Hello\n     \n    \"\"\"","ref":"Idmlx.Components.TextFrame.html#to_html/3-examples"},{"type":"module","title":"Idmlx.HTML.Export","doc":"","ref":"Idmlx.HTML.Export.html"},{"type":"function","title":"Idmlx.HTML.Export.call/3","doc":"","ref":"Idmlx.HTML.Export.html#call/3"},{"type":"function","title":"Idmlx.HTML.Export.page_fonts/1","doc":"","ref":"Idmlx.HTML.Export.html#page_fonts/1"},{"type":"function","title":"Idmlx.HTML.Export.page_styles/1","doc":"","ref":"Idmlx.HTML.Export.html#page_styles/1"},{"type":"module","title":"Idmlx.Konva.Export","doc":"Provides functionality for exporting InDesign spreads to KonvaJS format.","ref":"Idmlx.Konva.Export.html"},{"type":"function","title":"Idmlx.Konva.Export.call/3","doc":"Converts a spread to KonvaJS JSON format.","ref":"Idmlx.Konva.Export.html#call/3"},{"type":"function","title":"Parameters - Idmlx.Konva.Export.call/3","doc":"- `page`: The page or spread to convert\n- `assigns`: Map of element name to assigned text content\n- `mode`: Rendering mode (:filled or :wireframes)","ref":"Idmlx.Konva.Export.html#call/3-parameters"},{"type":"function","title":"Returns - Idmlx.Konva.Export.call/3","doc":"JSON string representing the KonvaJS stage","ref":"Idmlx.Konva.Export.html#call/3-returns"},{"type":"module","title":"Idmlx.Konva.Import","doc":"","ref":"Idmlx.Konva.Import.html"},{"type":"function","title":"Idmlx.Konva.Import.from_json/1","doc":"","ref":"Idmlx.Konva.Import.html#from_json/1"},{"type":"module","title":"Idmlx.StyleCreator.CharacterStyleCreator","doc":"Module responsible for creating Character Style XML blocks for InDesign IDML documents.\n\nThis module provides functions to create and customize character styles with\nattributes such as font, size, color, and various text decorations.","ref":"Idmlx.StyleCreator.CharacterStyleCreator.html"},{"type":"function","title":"Idmlx.StyleCreator.CharacterStyleCreator.apply_style_options/2","doc":"Applies the style options to the base attributes map.","ref":"Idmlx.StyleCreator.CharacterStyleCreator.html#apply_style_options/2"},{"type":"function","title":"Idmlx.StyleCreator.CharacterStyleCreator.create/2","doc":"Creates a new character style with the given name and options.","ref":"Idmlx.StyleCreator.CharacterStyleCreator.html#create/2"},{"type":"function","title":"Options - Idmlx.StyleCreator.CharacterStyleCreator.create/2","doc":"* `:font` - Font name to use (string)\n* `:font_style` - Font style such as \"Regular\", \"Bold\", \"Italic\", etc. (string)\n* `:point_size` - Text size in points (number)\n* `:fill_color` - Text color name or RGB/CMYK values\n* `:tracking` - Letter spacing (number)\n* `:capitalization` - Text case transformation, e.g., \"Normal\", \"AllCaps\", \"SmallCaps\" (string)\n* `:underline` - Whether text is underlined (boolean)\n* `:strike_thru` - Whether text has strikethrough (boolean)\n* `:position` - Text position, e.g., \"Normal\", \"Superscript\", \"Subscript\" (string)\n* `:imported` - Whether the style is imported (boolean)\n* `:style_unique_id` - Unique ID for the style (string, generated if not provided)\n* Any other attributes defined in the CharacterStyle attributes schema","ref":"Idmlx.StyleCreator.CharacterStyleCreator.html#create/2-options"},{"type":"function","title":"Examples - Idmlx.StyleCreator.CharacterStyleCreator.create/2","doc":"iex> Idmlx.StyleCreator.CharacterStyleCreator.create(\"Heading\", %{\n    ...>   font: \"Minion Pro\",\n    ...>   font_style: \"Bold\",\n    ...>   point_size: 24,\n    ...>   fill_color: \"Black\"\n    ...> })","ref":"Idmlx.StyleCreator.CharacterStyleCreator.html#create/2-examples"},{"type":"function","title":"Idmlx.StyleCreator.CharacterStyleCreator.create_properties_element/1","doc":"Creates an inner Properties element containing font and other complex properties.\n\nThis is needed for some attributes that can't be represented as simple string attributes.","ref":"Idmlx.StyleCreator.CharacterStyleCreator.html#create_properties_element/1"},{"type":"function","title":"Idmlx.StyleCreator.CharacterStyleCreator.format_style_with_properties/2","doc":"Formats a character style element with potential inner Properties element.","ref":"Idmlx.StyleCreator.CharacterStyleCreator.html#format_style_with_properties/2"},{"type":"module","title":"Idmlx.StyleCreator.ColorHelper","doc":"Utility module for handling color-related operations for IDML documents.","ref":"Idmlx.StyleCreator.ColorHelper.html"},{"type":"function","title":"Idmlx.StyleCreator.ColorHelper.create_color_definition/2","doc":"Creates a new color definition for IDML.\nThis would be used when you need to create custom colors that don't already exist in the document.","ref":"Idmlx.StyleCreator.ColorHelper.html#create_color_definition/2"},{"type":"function","title":"Idmlx.StyleCreator.ColorHelper.create_color_xml/1","doc":"Creates a complete color XML definition for insertion into an IDMS document.","ref":"Idmlx.StyleCreator.ColorHelper.html#create_color_xml/1"},{"type":"function","title":"Parameters - Idmlx.StyleCreator.ColorHelper.create_color_xml/1","doc":"- name: The name of the color.\n- options: Options for the color definition.","ref":"Idmlx.StyleCreator.ColorHelper.html#create_color_xml/1-parameters"},{"type":"function","title":"Options - Idmlx.StyleCreator.ColorHelper.create_color_xml/1","doc":"- `:type` - Color type, one of \"cmyk\", \"rgb\", \"lab\", \"hex\", etc.\n- `:values` - List of color values or hex string for hex type.\n- `:space` - Color space (defaults based on type).\n- `:model` - Color model (defaults to \"Process\").\n- `:visible` - Whether the color is visible (defaults to true).\n- `:editable` - Whether the color is editable (defaults to true).\n- `:removable` - Whether the color is removable (defaults to true).","ref":"Idmlx.StyleCreator.ColorHelper.html#create_color_xml/1-options"},{"type":"function","title":"Examples - Idmlx.StyleCreator.ColorHelper.create_color_xml/1","doc":"iex> Idmlx.StyleCreator.ColorHelper.create_color_xml(\"MochaMousse\", %{\n    ...>   type: \"cmyk\",\n    ...>   values: [30, 50, 75, 10]\n    ...> })\n    # Returns XML string with the color definition\n\n    iex> Idmlx.StyleCreator.ColorHelper.create_color_xml(\"BrightRed\", %{\n    ...>   type: \"hex\",\n    ...>   values: \"#FF0000\"\n    ...> })\n    # Returns XML string with converted CMYK color definition","ref":"Idmlx.StyleCreator.ColorHelper.html#create_color_xml/1-examples"},{"type":"function","title":"Idmlx.StyleCreator.ColorHelper.format_color/1","doc":"Formats a color object or name into the format expected by InDesign.","ref":"Idmlx.StyleCreator.ColorHelper.html#format_color/1"},{"type":"function","title":"Examples - Idmlx.StyleCreator.ColorHelper.format_color/1","doc":"iex> Idmlx.StyleCreator.ColorHelper.format_color(\"Black\")\n    \"Color/Black\"\n\n    iex> Idmlx.StyleCreator.ColorHelper.format_color(%{type: \"cmyk\", values: [0, 0, 0, 100]})\n    # Would return an appropriate CMYK color reference\n\n    iex> Idmlx.StyleCreator.ColorHelper.format_color(%{type: \"hex\", values: \"#FF0000\"})\n    # Would convert hex to CMYK and return appropriate reference","ref":"Idmlx.StyleCreator.ColorHelper.html#format_color/1-examples"},{"type":"function","title":"Idmlx.StyleCreator.ColorHelper.hex_to_cmyk/1","doc":"Converts a hex color value to CMYK values.\nReturns a tuple of {C, M, Y, K} values as percentages (0-100).","ref":"Idmlx.StyleCreator.ColorHelper.html#hex_to_cmyk/1"},{"type":"function","title":"Examples - Idmlx.StyleCreator.ColorHelper.hex_to_cmyk/1","doc":"iex> Idmlx.StyleCreator.ColorHelper.hex_to_cmyk(\"#FF0000\")\n    {0, 100, 100, 0}\n\n    iex> Idmlx.StyleCreator.ColorHelper.hex_to_cmyk(\"#000000\")\n    {0, 0, 0, 100}","ref":"Idmlx.StyleCreator.ColorHelper.html#hex_to_cmyk/1-examples"},{"type":"function","title":"Idmlx.StyleCreator.ColorHelper.rgb_to_cmyk/3","doc":"Converts RGB values (0-255) to CMYK values (0-100).","ref":"Idmlx.StyleCreator.ColorHelper.html#rgb_to_cmyk/3"},{"type":"module","title":"Idmlx.StyleCreator.ObjectStyleCreator","doc":"Module responsible for creating Object Style XML blocks for InDesign IDML documents.\n\nThis module provides functions to create and customize object styles with\nattributes such as fill, stroke, corner options, and text frame properties.","ref":"Idmlx.StyleCreator.ObjectStyleCreator.html"},{"type":"function","title":"Idmlx.StyleCreator.ObjectStyleCreator.apply_style_options/2","doc":"Applies the style options to the base attributes map.","ref":"Idmlx.StyleCreator.ObjectStyleCreator.html#apply_style_options/2"},{"type":"function","title":"Idmlx.StyleCreator.ObjectStyleCreator.create/2","doc":"Creates a new object style with the given name and options.","ref":"Idmlx.StyleCreator.ObjectStyleCreator.html#create/2"},{"type":"function","title":"Options - Idmlx.StyleCreator.ObjectStyleCreator.create/2","doc":"* `:fill_color` - Fill color name or RGB/CMYK values\n* `:fill_tint` - Tint percentage for the fill color (0-100)\n* `:stroke_color` - Stroke color name or RGB/CMYK values\n* `:stroke_weight` - Width of the stroke\n* `:corner_radius` - Radius for rounded corners\n* `:applied_paragraph_style` - Paragraph style to apply to text in the object\n* `:stroke_type` - Type of stroke (e.g., \"StrokeStyle/$ID/Solid\")\n* `:corner_option` - Corner style (e.g., \"None\", \"RoundedCorner\")\n* `:imported` - Whether the style is imported (boolean)\n* `:style_unique_id` - Unique ID for the style (string, generated if not provided)\n* `:based_on` - The parent style this style inherits from (string)\n* Any other attributes defined in the ObjectStyle attributes schema","ref":"Idmlx.StyleCreator.ObjectStyleCreator.html#create/2-options"},{"type":"function","title":"Examples - Idmlx.StyleCreator.ObjectStyleCreator.create/2","doc":"iex> Idmlx.StyleCreator.ObjectStyleCreator.create(\"TextFrame\", %{\n    ...>   fill_color: \"None\",\n    ...>   stroke_color: \"Black\",\n    ...>   stroke_weight: 1,\n    ...>   corner_radius: 0,\n    ...>   applied_paragraph_style: \"ParagraphStyle/BodyText\"\n    ...> })","ref":"Idmlx.StyleCreator.ObjectStyleCreator.html#create/2-examples"},{"type":"function","title":"Idmlx.StyleCreator.ObjectStyleCreator.create_properties_element/1","doc":"Creates an inner Properties element containing complex properties for an object style.","ref":"Idmlx.StyleCreator.ObjectStyleCreator.html#create_properties_element/1"},{"type":"function","title":"Idmlx.StyleCreator.ObjectStyleCreator.format_style_with_properties/2","doc":"Formats an object style element with potential inner Properties element.","ref":"Idmlx.StyleCreator.ObjectStyleCreator.html#format_style_with_properties/2"},{"type":"module","title":"Idmlx.StyleCreator.ParagraphStyleCreator","doc":"Module responsible for creating Paragraph Style XML blocks for InDesign IDML documents.\n\nThis module provides functions to create and customize paragraph styles with\nattributes such as alignment, indentation, spacing, and various text formatting options.","ref":"Idmlx.StyleCreator.ParagraphStyleCreator.html"},{"type":"function","title":"Idmlx.StyleCreator.ParagraphStyleCreator.apply_style_options/2","doc":"Applies the style options to the base attributes map.","ref":"Idmlx.StyleCreator.ParagraphStyleCreator.html#apply_style_options/2"},{"type":"function","title":"Idmlx.StyleCreator.ParagraphStyleCreator.create/2","doc":"Creates a new paragraph style with the given name and options.","ref":"Idmlx.StyleCreator.ParagraphStyleCreator.html#create/2"},{"type":"function","title":"Options - Idmlx.StyleCreator.ParagraphStyleCreator.create/2","doc":"* `:font` - Font name to use (string)\n* `:font_style` - Font style such as \"Regular\", \"Bold\", \"Italic\", etc. (string)\n* `:point_size` - Text size in points (number)\n* `:fill_color` - Text color name or RGB/CMYK values\n* `:justification` - Paragraph alignment like \"LeftAlign\", \"CenterAlign\", \"RightAlign\", \"FullyJustified\" (string)\n* `:space_before` - Space before paragraph (number)\n* `:space_after` - Space after paragraph (number)\n* `:left_indent` - Left indent of paragraph (number)\n* `:right_indent` - Right indent of paragraph (number)\n* `:first_line_indent` - First line indent (number)\n* `:auto_leading` - Auto leading percentage (number, typically 120 for 120%)\n* `:next_style` - The style to apply to the next paragraph (string)\n* `:imported` - Whether the style is imported (boolean)\n* `:style_unique_id` - Unique ID for the style (string, generated if not provided)\n* `:based_on` - The parent style this style inherits from (string)\n* Any character style attributes or other paragraph attributes defined in the schema","ref":"Idmlx.StyleCreator.ParagraphStyleCreator.html#create/2-options"},{"type":"function","title":"Examples - Idmlx.StyleCreator.ParagraphStyleCreator.create/2","doc":"iex> Idmlx.StyleCreator.ParagraphStyleCreator.create(\"Body Text\", %{\n    ...>   font: \"Minion Pro\",\n    ...>   point_size: 12,\n    ...>   justification: \"LeftAlign\",\n    ...>   space_after: 12,\n    ...>   left_indent: 0,\n    ...>   first_line_indent: 18\n    ...> })","ref":"Idmlx.StyleCreator.ParagraphStyleCreator.html#create/2-examples"},{"type":"function","title":"Idmlx.StyleCreator.ParagraphStyleCreator.create_properties_element/1","doc":"Creates an inner Properties element containing complex properties for a paragraph style.","ref":"Idmlx.StyleCreator.ParagraphStyleCreator.html#create_properties_element/1"},{"type":"function","title":"Idmlx.StyleCreator.ParagraphStyleCreator.format_style_with_properties/2","doc":"Formats a paragraph style element with potential inner Properties element.","ref":"Idmlx.StyleCreator.ParagraphStyleCreator.html#format_style_with_properties/2"},{"type":"module","title":"Idmlx.Updater","doc":"A module for updating the contents of an .idms file, including page items, styles, and colors.\nSupports updating TextFrames, Rectangles, and inserting Character, Paragraph, and Object styles.","ref":"Idmlx.Updater.html"},{"type":"function","title":"Idmlx.Updater.update_colors/2","doc":"Updates colors in the IDMS document.","ref":"Idmlx.Updater.html#update_colors/2"},{"type":"function","title":"Idmlx.Updater.update_idms/3","doc":"Updates the contents of an .idms file with style definitions and content updates.","ref":"Idmlx.Updater.html#update_idms/3"},{"type":"function","title":"Parameters - Idmlx.Updater.update_idms/3","doc":"- payload: Map containing styles, colors and items to update:\n  - paragraph_styles: List of paragraph style definitions\n  - character_styles: List of character style definitions\n  - object_styles: List of object style definitions\n  - colors: List of color definitions\n  - items: List of items to update with their content\n- file_path: The path to the .idms file or URL to be updated.\n- new_file_path: Optional path for the updated file (defaults to \"./updated.idms\").","ref":"Idmlx.Updater.html#update_idms/3-parameters"},{"type":"function","title":"Examples - Idmlx.Updater.update_idms/3","doc":"iex> payload = %{\n    ...>   paragraph_styles: [style_def],\n    ...>   items: [%{name: \"text1\", type: :text_frame, content: \"New content\"}]\n    ...> }\n    iex> Idmlx.Updater.update_idms(payload, \"path/to/file.idms\")\n    :ok\n\n    iex> Idmlx.Updater.update_idms(payload, \"https://example.com/template.idms\")\n    :ok","ref":"Idmlx.Updater.html#update_idms/3-examples"},{"type":"module","title":"Idmlx.Updater.Items","doc":"Functions for updating items in IDMS files.","ref":"Idmlx.Updater.Items.html"},{"type":"function","title":"Idmlx.Updater.Items.update_item_in_xml/2","doc":"Updates a Rectangle element in the XML.","ref":"Idmlx.Updater.Items.html#update_item_in_xml/2"},{"type":"function","title":"Idmlx.Updater.Items.update_items/2","doc":"Updates the contents of items in the IDMS document.","ref":"Idmlx.Updater.Items.html#update_items/2"},{"type":"module","title":"Idmlx.Updater.Stories","doc":"Functions for handling story content in IDMS files.","ref":"Idmlx.Updater.Stories.html"},{"type":"function","title":"Idmlx.Updater.Stories.create_story_content/1","doc":"Creates properly formatted story content XML with styling.","ref":"Idmlx.Updater.Stories.html#create_story_content/1"},{"type":"function","title":"Parameters - Idmlx.Updater.Stories.create_story_content/1","doc":"- attrs: Map containing content and styling information:\n  - content: The text content\n  - applied_paragraph_style: Optional paragraph style reference\n  - applied_character_style: Optional character style reference (defaults to [No character style])","ref":"Idmlx.Updater.Stories.html#create_story_content/1-parameters"},{"type":"function","title":"Idmlx.Updater.Stories.element_children/1","doc":"Gets the children of an XML element.","ref":"Idmlx.Updater.Stories.html#element_children/1"},{"type":"function","title":"Idmlx.Updater.Stories.get_story_reference/1","doc":"Gets the Story reference from a TextFrame element.","ref":"Idmlx.Updater.Stories.html#get_story_reference/1"},{"type":"function","title":"Idmlx.Updater.Stories.update_element_with_content/2","doc":"Updates the content of an element (used for Story elements).","ref":"Idmlx.Updater.Stories.html#update_element_with_content/2"},{"type":"function","title":"Idmlx.Updater.Stories.update_story_content/3","doc":"Updates the content of a Story element with proper styling.","ref":"Idmlx.Updater.Stories.html#update_story_content/3"},{"type":"module","title":"Idmlx.Updater.Styles","doc":"Functions for updating styles in IDMS files.","ref":"Idmlx.Updater.Styles.html"},{"type":"function","title":"Idmlx.Updater.Styles.insert_elements_into_group/2","doc":"Helper function to insert elements into a group element.","ref":"Idmlx.Updater.Styles.html#insert_elements_into_group/2"},{"type":"function","title":"Idmlx.Updater.Styles.update_character_styles/2","doc":"Inserts character styles into the RootCharacterStyleGroup element.","ref":"Idmlx.Updater.Styles.html#update_character_styles/2"},{"type":"function","title":"Idmlx.Updater.Styles.update_object_styles/2","doc":"Inserts object styles into the RootObjectStyleGroup element.","ref":"Idmlx.Updater.Styles.html#update_object_styles/2"},{"type":"function","title":"Idmlx.Updater.Styles.update_paragraph_styles/2","doc":"Inserts paragraph styles into the RootParagraphStyleGroup element.","ref":"Idmlx.Updater.Styles.html#update_paragraph_styles/2"},{"type":"function","title":"Idmlx.Updater.Styles.update_styles/2","doc":"Updates styles in the IDMS document.","ref":"Idmlx.Updater.Styles.html#update_styles/2"},{"type":"module","title":"Idmlx.Updater.XML","doc":"Helper functions for XML manipulation in IDMS files.","ref":"Idmlx.Updater.XML.html"},{"type":"function","title":"Idmlx.Updater.XML.maybe_update_attribute/3","doc":"Updates an attribute of an XML element if the value is present.","ref":"Idmlx.Updater.XML.html#maybe_update_attribute/3"},{"type":"function","title":"Idmlx.Updater.XML.normalize_attribute_value/1","doc":"Normalizes attribute values for XML elements.","ref":"Idmlx.Updater.XML.html#normalize_attribute_value/1"},{"type":"function","title":"Idmlx.Updater.XML.replace_element/3","doc":"Replaces a single element in an XML document.","ref":"Idmlx.Updater.XML.html#replace_element/3"},{"type":"function","title":"Idmlx.Updater.XML.replace_elements/3","doc":"Replaces elements in an XML document.","ref":"Idmlx.Updater.XML.html#replace_elements/3"},{"type":"function","title":"Idmlx.Updater.XML.update_element_attribute/3","doc":"Updates an attribute of an XML element.","ref":"Idmlx.Updater.XML.html#update_element_attribute/3"},{"type":"module","title":"Idmlx.Utils.Normalizer","doc":"A utility module for normalizing string values into their respective types.","ref":"Idmlx.Utils.Normalizer.html"},{"type":"function","title":"Idmlx.Utils.Normalizer.normalize_value/1","doc":"Normalizes a given value by converting it to an integer, float, or boolean if possible.","ref":"Idmlx.Utils.Normalizer.html#normalize_value/1"},{"type":"function","title":"Parameters - Idmlx.Utils.Normalizer.normalize_value/1","doc":"- value: The value to be normalized. It can be a string representing an integer, float, or boolean.","ref":"Idmlx.Utils.Normalizer.html#normalize_value/1-parameters"},{"type":"function","title":"Examples - Idmlx.Utils.Normalizer.normalize_value/1","doc":"iex> Normalizer.normalize_value(\"123\")\n    123\n\n    iex> Normalizer.normalize_value(\"123.45\")\n    123.45\n\n    iex> Normalizer.normalize_value(\"true\")\n    true\n\n    iex> Normalizer.normalize_value(\"some string\")\n    \"some string\"","ref":"Idmlx.Utils.Normalizer.html#normalize_value/1-examples"},{"type":"module","title":"Idmlx.Utils.PrinceXML","doc":"","ref":"Idmlx.Utils.PrinceXML.html"},{"type":"function","title":"Idmlx.Utils.PrinceXML.merge_output/1","doc":"","ref":"Idmlx.Utils.PrinceXML.html#merge_output/1"},{"type":"function","title":"Idmlx.Utils.PrinceXML.remove_first_page/1","doc":"","ref":"Idmlx.Utils.PrinceXML.html#remove_first_page/1"},{"type":"function","title":"Idmlx.Utils.PrinceXML.render/3","doc":"","ref":"Idmlx.Utils.PrinceXML.html#render/3"},{"type":"function","title":"Idmlx.Utils.PrinceXML.render_image/3","doc":"","ref":"Idmlx.Utils.PrinceXML.html#render_image/3"},{"type":"module","title":"Idmlx.Utils.RNC","doc":"","ref":"Idmlx.Utils.RNC.html"},{"type":"function","title":"Idmlx.Utils.RNC.parse/1","doc":"","ref":"Idmlx.Utils.RNC.html#parse/1"},{"type":"module","title":"Idmlx.Utils.RNC.Attributes","doc":"","ref":"Idmlx.Utils.RNC.Attributes.html"},{"type":"function","title":"Idmlx.Utils.RNC.Attributes.parse_attributes/2","doc":"","ref":"Idmlx.Utils.RNC.Attributes.html#parse_attributes/2"},{"type":"module","title":"Idmlx.Utils.RNC.Datatypes","doc":"","ref":"Idmlx.Utils.RNC.Datatypes.html"},{"type":"function","title":"Idmlx.Utils.RNC.Datatypes.parse_enums/1","doc":"","ref":"Idmlx.Utils.RNC.Datatypes.html#parse_enums/1"},{"type":"module","title":"Idmlx.Utils.Transform","doc":"","ref":"Idmlx.Utils.Transform.html"},{"type":"function","title":"Idmlx.Utils.Transform.calculate_transform_matrix/3","doc":"Calculates a 2x3 transformation matrix that maps the old coordinates to the new coordinates.","ref":"Idmlx.Utils.Transform.html#calculate_transform_matrix/3"},{"type":"function","title":"Parameters - Idmlx.Utils.Transform.calculate_transform_matrix/3","doc":"- `old_coords`: A list of four elements representing the old coordinates `[x1_old, x2_old, y1_old, y2_old]`.\n  - `new_coords`: A list of four elements representing the new coordinates `[x1_new, x2_new, y1_new, y2_new]`.","ref":"Idmlx.Utils.Transform.html#calculate_transform_matrix/3-parameters"},{"type":"function","title":"Returns - Idmlx.Utils.Transform.calculate_transform_matrix/3","doc":"- A list of six elements representing the transformation matrix `[a, b, c, d, e, f]` where:\n    - `a` is the scaling factor in the x direction multiplied by the cosine of the rotation angle.\n    - `b` is the scaling factor in the x direction multiplied by the sine of the rotation angle.\n    - `c` is the negative scaling factor in the y direction multiplied by the sine of the rotation angle.\n    - `d` is the scaling factor in the y direction multiplied by the cosine of the rotation angle.\n    - `e` is the translation in the x direction.\n    - `f` is the translation in the y direction.","ref":"Idmlx.Utils.Transform.html#calculate_transform_matrix/3-returns"},{"type":"function","title":"Example - Idmlx.Utils.Transform.calculate_transform_matrix/3","doc":"iex> Transform.calculate_transform_matrix([0, 2, 0, 2], [1, 3, 1, 3])\n    [1.0, 0.0, 0.0, 1.0, 1.0, 1.0]","ref":"Idmlx.Utils.Transform.html#calculate_transform_matrix/3-example"},{"type":"behaviour","title":"Idmlx.Utils.Unzip","doc":"A utility module for unzipping files.","ref":"Idmlx.Utils.Unzip.html"},{"type":"function","title":"Idmlx.Utils.Unzip.unzip_file/2","doc":"","ref":"Idmlx.Utils.Unzip.html#unzip_file/2"},{"type":"callback","title":"Idmlx.Utils.Unzip.unzip_file/2","doc":"Unzips the specified ZIP file to the given destination path.","ref":"Idmlx.Utils.Unzip.html#c:unzip_file/2"},{"type":"callback","title":"Parameters - Idmlx.Utils.Unzip.unzip_file/2","doc":"- `zip_path` (string): The path to the ZIP file to be extracted.\n  - `destination_path` (string): The path where the contents of the ZIP file should be extracted.","ref":"Idmlx.Utils.Unzip.html#c:unzip_file/2-parameters"},{"type":"callback","title":"Returns - Idmlx.Utils.Unzip.unzip_file/2","doc":"- `{:ok, files}`: A tuple containing `:ok` and a list of extracted files if the operation is successful.\n  - `{:error, reason}`: A tuple containing `:error` and the reason for failure if the operation fails.","ref":"Idmlx.Utils.Unzip.html#c:unzip_file/2-returns"},{"type":"callback","title":"Examples - Idmlx.Utils.Unzip.unzip_file/2","doc":"iex> Idmlx.Utils.Unzip.unzip_file(\"path/to/zipfile.zip\", \"path/to/destination\")\n    {:ok, [\"file1.txt\", \"file2.txt\"]}\n\n    iex> Idmlx.Utils.Unzip.unzip_file(\"invalid/path.zip\", \"path/to/destination\")\n    {:error, :enoent}","ref":"Idmlx.Utils.Unzip.html#c:unzip_file/2-examples"},{"type":"module","title":"Idmlx.Utils.Xml","doc":"A utility module for parsing, creating, and manipulating XML content.\nProvides functionality for both reading XML files and building XML elements.","ref":"Idmlx.Utils.Xml.html"},{"type":"function","title":"Idmlx.Utils.Xml.create_element/3","doc":"Creates an XML element with the given name, attributes, and content.","ref":"Idmlx.Utils.Xml.html#create_element/3"},{"type":"function","title":"Examples - Idmlx.Utils.Xml.create_element/3","doc":"iex> Idmlx.Utils.Xml.create_element(\"CharacterStyle\", %{\"Name\" => \"Heading\"})\n    %{name: \"CharacterStyle\", attributes: %{\"Name\" => \"Heading\"}, content: []}\n\n    iex> Idmlx.Utils.Xml.create_element(\"Properties\", %{}, [\"Some content\"])\n    %{name: \"Properties\", attributes: %{}, content: [\"Some content\"]}","ref":"Idmlx.Utils.Xml.html#create_element/3-examples"},{"type":"function","title":"Idmlx.Utils.Xml.export_fragment/2","doc":"Exports a fragment of an XML file based on the given XPath.","ref":"Idmlx.Utils.Xml.html#export_fragment/2"},{"type":"function","title":"Parameters - Idmlx.Utils.Xml.export_fragment/2","doc":"- `file_path`: The path to the XML file.\n- `xpath`: The XPath specification for selecting the fragment to export.","ref":"Idmlx.Utils.Xml.html#export_fragment/2-parameters"},{"type":"function","title":"Returns - Idmlx.Utils.Xml.export_fragment/2","doc":"- The selected XML fragment.\n- `{:error, reason}`: An error tuple with a reason for failure.","ref":"Idmlx.Utils.Xml.html#export_fragment/2-returns"},{"type":"function","title":"Idmlx.Utils.Xml.parse/3","doc":"Parses an XML file based on the given specification and optional subspecification.","ref":"Idmlx.Utils.Xml.html#parse/3"},{"type":"function","title":"Parameters - Idmlx.Utils.Xml.parse/3","doc":"- `file_path`: The path to the XML file.\n- `spec`: The main XPath specification for parsing.\n- `subspec`: An optional list of subspecifications for more detailed parsing.","ref":"Idmlx.Utils.Xml.html#parse/3-parameters"},{"type":"function","title":"Returns - Idmlx.Utils.Xml.parse/3","doc":"- `{:ok, dom}`: The parsed XML document object model.\n- `{:error, reason}`: An error tuple with a reason for failure.","ref":"Idmlx.Utils.Xml.html#parse/3-returns"},{"type":"function","title":"Idmlx.Utils.Xml.parse_attributes/2","doc":"Parses attributes from an XML file based on the given specification.","ref":"Idmlx.Utils.Xml.html#parse_attributes/2"},{"type":"function","title":"Parameters - Idmlx.Utils.Xml.parse_attributes/2","doc":"- `file_path`: The path to the XML file.\n- `spec`: The XPath specification for selecting elements whose attributes are to be parsed.","ref":"Idmlx.Utils.Xml.html#parse_attributes/2-parameters"},{"type":"function","title":"Returns - Idmlx.Utils.Xml.parse_attributes/2","doc":"- A list of maps containing attribute key-value pairs for each selected element.\n- `{:error, reason}`: An error tuple with a reason for failure.","ref":"Idmlx.Utils.Xml.html#parse_attributes/2-returns"},{"type":"function","title":"Idmlx.Utils.Xml.parse_xml/2","doc":"","ref":"Idmlx.Utils.Xml.html#parse_xml/2"},{"type":"function","title":"Idmlx.Utils.Xml.parse_xml/3","doc":"","ref":"Idmlx.Utils.Xml.html#parse_xml/3"},{"type":"function","title":"Idmlx.Utils.Xml.to_xml_string/1","doc":"Converts an XML element to a string representation.","ref":"Idmlx.Utils.Xml.html#to_xml_string/1"},{"type":"extras","title":"IDMLx","doc":"# IDMLx\n\n![Logo](./logo.jpeg)\n\nIDMLx is an Elixir library for parsing IDML/IDMS files from Adobe InDesign into Elixir structs. These structs can be filled with data and exported to various formats such as KonvaJS canvas, PNG, HTML, or PDFs.","ref":"readme.html"},{"type":"extras","title":"Features - IDMLx","doc":"- Parse IDML/IDMS files into Elixir structs\n- Manipulate and fill structs with data\n- Export data to various formats including KonvaJS canvas, PNG, HTML, and PDFs","ref":"readme.html#features"},{"type":"extras","title":"Installation - IDMLx","doc":"Add `idmlx` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:idmlx, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - IDMLx","doc":"","ref":"readme.html#usage"},{"type":"extras","title":"Reading IDMS files - IDMLx","doc":"```elixir\n# Read an IDMS file\nspread = Idmlx.read_idms(\"path/to/file.idms\")\n\n# Extract text frames\ntext_frames = Idmlx.text_frames(spread)\n\n# Extract images\nimages = Idmlx.images(spread)\n```","ref":"readme.html#reading-idms-files"},{"type":"extras","title":"Exporting to KonvaJS - IDMLx","doc":"```elixir\n# Export to KonvaJS format\nkonva_json = Idmlx.export_to_konva(spread)\n\n# Export with custom text assignments\nkonva_json = Idmlx.export_to_konva(spread, %{\n  \"TextFrame1\" => \"Custom text content\"\n})\n\n# Export in wireframe mode\nkonva_json = Idmlx.export_to_konva(spread, %{}, mode: :wireframes)\n```","ref":"readme.html#exporting-to-konvajs"},{"type":"extras","title":"Updating IDMS files - IDMLx","doc":"```elixir\n# Update an IDMS file with modified spread\nIdmlx.update_idms(spread, \"path/to/original.idms\", \"path/to/updated.idms\")\n```","ref":"readme.html#updating-idms-files"},{"type":"extras","title":"Documentation - IDMLx","doc":"Full documentation can be found at [https://hexdocs.pm/idmlx](https://hexdocs.pm/idmlx).","ref":"readme.html#documentation"},{"type":"extras","title":"License - IDMLx","doc":"This project is licensed under the MIT License - see the LICENSE file for details.","ref":"readme.html#license"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}